#include "Seek.h"

char tori[ITEM_COUNT][SMALL_BUFFER_SIZE];
int item;
extern VOYA_SETTING *vs;
VOYA_ERROR buffer_open_name_remove;
VOYA_ERROR *ve = &buffer_open_name_remove;

static const char NEW_LINE[2] = {'\n', '\0'};
static char voya_error[ITEM_COUNT][SMALL_BUFFER_SIZE];
static int index;
static TimeName t;
static TimeName *time_name = &t;

BOOL removeVoyaErrorFiles(void) {
    char *p;
    char c[SMALL_BUFFER_SIZE];
    FILE *file = fopen(REMOVE_ERROR_TEXT, "rt");
    if(file == NULL) {
        return 0; /* FALSE */
    }

    for(;;) {
        p = fgets(c, SMALL_BUFFER_SIZE, file);
        if(p == NULL) {
            break;
        }

        remove(c);
    }

    fclose(file);
    return TRUE;
}

long modified_file(char *s) {
    long g;
    struct stat file_time;
    struct tm *p;

    if(! stat(s, &file_time) ) {
        p = gmtime( &(file_time.st_mtime) );
        g = p->tm_sec + 60*p->tm_min + 60*60*p->tm_hour + 60*60*24*p->tm_yday;
    } else {
        g = 0L;
    }

    return g;
}

void closeVoyaError(void) {
    if(ve->voyaErrorOpen) {
        fclose(ve->voyaError);
        ve->voyaErrorOpen = 0; /* FALSE */
    }

}

void createVoyaLog(char *message) {
    FILE *file = fopen(VOYA_LOG, "wt");
    fprintf(file, "%s\n", message);
    fclose(file);
}

void makeBatchFile(void) {
    char *p;
    FILE *file;
    int k;

    strcpy(ve->buffer, "COPY /B ");
    strcat(ve->buffer, vs->log_file_name);
    for(k = 0; tori[k][0] != '\0'; k++) {
        strcat(ve->buffer, "+");

        p = & tori[k][0];
        strcat(ve->buffer, p);
    }

    strcat(ve->buffer, " ");

// temporary file name
    strcpy(time_name->base, VOY);
    strcpy(time_name->extension, TEMPORARY);
    strcpy(time_name->name, time_name->base);
    strcpy(ve->voyaErrorName, temporaryName(time_name, SERIAL_NUMBER) );

    p = & voya_error[index][0];
    strcpy(p, ve->voyaErrorName);

    strcat(ve->buffer, ve->voyaErrorName);
    strcat(ve->buffer, NEW_LINE);
    strcat(ve->buffer, "DEL ");
    strcat(ve->buffer, vs->log_file_name);
    strcat(ve->buffer, NEW_LINE);
    strcat(ve->buffer, "REN "); // rename
    strcat(ve->buffer, ve->voyaErrorName);
    strcat(ve->buffer, " ");
    strcat(ve->buffer, vs->log_file_name);
    strcat(ve->buffer, NEW_LINE);

    if(ve->removeVoyaError) {
        for(k = index - 1; k >= 0; k--) {
            strcat(ve->buffer, "DEL ");

            p = & voya_error[k][0];
            strcat(ve->buffer, p);
            strcat(ve->buffer, NEW_LINE);
        }

    }

    file = fopen(VOYA_LOG_BATCH, "wt");
    fputs(ve->buffer, file);
    fclose(file);
}

void openVoyaError(void) {
    char *p;

    strcpy(time_name->base, VOY);
    strcpy(time_name->extension, TEMPORARY);
    strcpy(time_name->name, time_name->base);
    strcpy(ve->voyaErrorName, temporaryName(time_name, SERIAL_NUMBER) );
    p = & voya_error[index][0];
    strcpy(p, ve->voyaErrorName);
    index += 1;

    ve->voyaError = fopen(ve->voyaErrorName, "wt");
    if(ve->voyaError == NULL) {
        ve->voyaErrorOpen = 0; /* FALSE */
    } else {
        ve->voyaErrorOpen = TRUE;
        p = & tori[item][0];
        strcpy(p, ve->voyaErrorName);
        item += 1;
    }
}

void voyaCountFlush(int count) {
    if(ve->voyaErrorOpen) {
        fprintf(ve->voyaError, "%d\n", count);
    }
}

void voyaMessage(const char *message) {
    if(ve->voyaErrorOpen) {
        fputs(message, ve->voyaError);
    }
}

void voyaMessageFlush(const char *message) {
    if(ve->voyaErrorOpen) {
        fprintf(ve->voyaError, "%s\n", message);
    }
}

void voyaSumFlush(double sum) {
    if(ve->voyaErrorOpen) {
        fprintf(ve->voyaError, "%f\n", sum);
    }
}

