#include "TimeName.h"

static char HYPHEN[] = "-";
static int sn; /* setSerialNumber(time_name) */

char *temporaryName(TimeName *time_name, BOOL serial_number) {
    char *time_name_text = & time_name->text[0];
    char minutes[3];
    char om[TIME_NAME_SIZE];
    char os[TIME_NAME_SIZE];
    char seconds[3];
    int m, sec;
    struct tm *time_block;
    time_t timer;
    timer = time(NULL);
    time_block = localtime(&timer);
    m = time_block->tm_min;
    sec = time_block->tm_sec;

    sprintf(minutes, "%02d", m);
    sprintf(seconds, "%02d", sec);

    if(serial_number) {
        setSerialNumber(time_name);
    }

    strcpy(os, time_name->name);
    strcat(os, minutes);
    strcat(os, HYPHEN);
    strcat(os, seconds);
    strcat(os, time_name->extension);
    if(! strcmp(os, time_name_text) ) {
        setSerialNumber(time_name);

        strcpy(om, time_name->name);
        strcat(om, minutes);
        strcat(om, HYPHEN);
        strcat(om, seconds);
        strcat(om, time_name->extension);

/* Copying */
        strcpy(os, om);
    }

    strcpy(time_name_text, os);
    return time_name_text;
}

void readSerialNumber(void) {
    char *p;
    char *stop;
    char buffer[SERIAL_BUFFER_SIZE];
    FILE *file = fopen(SERIAL_TEXT, "rt");
    if(file == NULL) {
        zeroSerialNumber();
    } else {
        p = fgets(buffer, SERIAL_BUFFER_SIZE, file);
        if(p == NULL) {
            fclose(file);
            zeroSerialNumber();
        } else {
            sn = (int)strtol(buffer, &stop, 10);
            fclose(file);
        }

    }

}

void setSerialNumber(TimeName *time_name) {
    char os[TIME_NAME_SIZE];
    char serial_number[TIME_NAME_SIZE];
    FILE *file = fopen(SERIAL_TEXT, "wt");

    ++sn;
    fprintf(file, "%d\n", sn);
    sprintf(serial_number, "%d", sn); /* sn equals 2, for example */

    strcpy(os, time_name->base); /* voy */
    strcat(os, serial_number); /* voy2 */
    strcat(os, HYPHEN); /* voy2- */

/* Copying */
    strcpy(time_name->name, os);

    fclose(file);
}

void zeroSerialNumber(void) {
    FILE *file = fopen(SERIAL_TEXT, "wt");
    sn = 0;
    fprintf(file, "%d\n", sn);
    fclose(file);
}

