#ifndef VOYA_H
#define VOYA_H

#define VERSION 1.23
#define ASCII_COUNT 95
#define ASCII_SET_ARRAY_SIZE 256
#define CHARACTER_COUNT 8
#define COMPLEMENT "/.."
#define EXTENDED_TABLE_SIZE 65536 /* unsigned 16-bit integers */
#define FROM_TO " -> "
#define HALF 128
#define INTEGER_SIZE 11 /* 2147483647 */
#define KANJI_SIZE_PLUS_ONE 3
#define MAXIMUM_RING_COUNT 36
#define NON_SEEKER -2
#define NON_TORI_LINE " _/_/_/_/_/"
#define REVERSE_COMPLEMENT "../"
#define SALT_SET_ARRAY_SIZE 128
#define SUM_EQUALS_ZERO "The sum of weight equals zero."
#define TABLE_SIZE 7552 /* > 7338 + 63 + 95 */
#define TEN_FIGURE_TORI 10
#define TIME_USED_AS_SEED 0L
#define TOO_LARGE_SUM "Large sum of weight. "
#define TOTAL_COLON "Total: "
#include "queue.h"
#include "Seek.h"
#include "voyaFile.h"
#include "voyaSetting.h"
#include <signal.h>
#include <windows.h>
#include <sys/types.h>
#include "regex.h" /* #include <regex.h> */

typedef char* (*CRYPT)(char*, char*);
typedef int (*SEEKER)(void);
typedef int (*REGCOMP)(regex_t *preg, const char *pattern, int cflags);
typedef int (*REGEXEC)(const regex_t *preg, const char *string, size_t nmatch, regmatch_t pmatch[], int eflags);
typedef void (*REGFREE)(regex_t *preg);

enum DISPLAY_MODES {NO_DISPLAYING, DISPLAY_LATEST, DISPLAY_TOTAL, LATEST_AND_TOTAL};
enum ERROR_CODES {ZERO_ERROR, REQUEST_LENGTH_ERROR, VOYA_CSV_ERROR, IDLING_ERROR, INTERIM_REPORT_ERROR, CRYPT_DLL_ERROR, GET_PROC_ADDRESS_ERROR, BOOL_MALLOC_ERROR, REGEX_ERROR, ERROR_COUNT};

BOOL readVoyaCtrlTextBeforehand(void);
BOOL repeating(void);
BOOL setByTriplet(int k, int m, int n);
BOOL threePlaces(int k, int m, int n);
BOOL voyaCtrlTextTouched(void);
BOOL voyaLogBatchProcessing(void);
char *parameter_of_numbered(char *a, int *mode);
char random_ascii(char *ascii);
double shiftJisKanaAscii(void);
int non_seeker(void);
int seekerAsDragonSeek(void);
int seekerAsLeftmostSalt(void);
int seekerAsLeftmostSeek(void);
int seekerAsRegularExpression(void);
int seekerAsRightmostSeek(void);
int seekerAsStandardSeek(void);
int seekerAsUnlessCaseSensitive(void);
int seekerAsUpperCaseRightmost(void);
long tickCount(void);
void defaultWeight(void);
void newTotal(void);
void random_salt(char *pair, char *salt);
void seekerAsWhat(void);
void showRing(void);
void signal_handler(int dummy);
void versionMessage(BOOL comments);

#endif /* VOYA_H */
