#include "voya.h"

/*
voya C-1.23
To find requested tori.
Copyright 2015 Sogaya

GCC

*/

extern char *queue[QUEUE_ARRAY_SIZE];
extern int queue_begin;
extern VOYA_SETTING *vs; /* voyaSetting.cpp */
volatile BOOL terminated;
VOYA_CONTROL voyaControl;
VOYA_CONTROL *vc = &voyaControl;
extern VOYA_ERROR *ve;

static BOOL *hugeTable; /* hugeTable[HALF][HALF][HALF] of 8 megabytes */
static BOOL leftmost_salt, removeFirst, removeVoyaError, toBeNormalized, universalTime, useAscii;
static char ascii_set[ASCII_SET_ARRAY_SIZE] =    {'!', '#', '$', '%', '(', ')', '*', '+', 0x2C, '-', '.', '/', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '=', '?', '@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', 0x5C, ']', '^', '_', '`', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~', '&', '"', 0x27, '<', '>', ' ', '!', '#', '$', '%', '(', ')', '*', '+', 0x2C, '-', '.', '/', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '=', '?', '@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', 0x5C, ']', '^', '_', '`', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~', '&', '"', 0x27, '<', '>', ' ', '!', '#', '$', '%', '(', ')', '*', '+', 0x2C, '-', '.', '/', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '=', '?', '@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', 0x5C, ']', '^', '_', '`', 'a', 'b', 'c', 'd', 'e', 'f', 'g'};
static char ascii_subset[ASCII_SET_ARRAY_SIZE] = {'!', '#', '$', '%', '(', ')', '*', '+', 0x2C, '-', '.', '/', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '=', '?', '@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', 0x5C, ']', '^', '_', '`', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~', ')', '*',  '+', '-', '.', '/', '!', '#', '$', '%', '(', ')', '*', '+', 0x2C, '-', '.', '/', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '=', '?', '@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', 0x5C, ']', '^', '_', '`', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~', ')', '*',  '+', '-', '.', '/', '!', '#', '$', '%', '(', ')', '*', '+', 0x2C, '-', '.', '/', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '=', '?', '@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', 0x5C, ']', '^', '_', '`', 'a', 'b', 'c', 'd', 'e', 'f', 'g'};
static char c[TABLE_SIZE][KANJI_SIZE_PLUS_ONE]; /* list of characters */
static char character[EXTENDED_TABLE_SIZE][KANJI_SIZE_PLUS_ONE];
static char reverseComplement[ TEN_FIGURE_TORI + 1 ];
static char salt_set[SALT_SET_ARRAY_SIZE] =    {'!', '#', '(', ')', '*', '+', '-', '.', '/', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~', '$', '%', '&', ' ', 0x2C, '"', 0x27, '!', '#', '(', ')', '*', '+', '-', '.', '/', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a'};
static char salt_subset[SALT_SET_ARRAY_SIZE] = {'!', '#', '(', ')', '*', '+', '-', '.', '/', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~', '$', '%', '*', '+',  '-', '.',  '/', '!', '#', '(', ')', '*', '+', '-', '.', '/', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a'};
static const double AIM = 30000.;
static const int RING_COUNT = QUEUE_ARRAY_SIZE - 1;
static long untouched;
static int bound, displayMode, ring_count;
static int w[TABLE_SIZE]; /* weight list */
static int width[EXTENDED_TABLE_SIZE];

BOOL readVoyaCtrlTextBeforehand(void) {
    char *p;
    char c[SMALL_BUFFER_SIZE];
    FILE *file;
    int k, line;
    int setting[VOYA_MODES_LIST_SIZE];

    file = fopen(VOYA_CTRL_TEXT, "rt");
    if(file == NULL) {
        return 0; /* FALSE */
    }

    for(k = 0; k < VOYA_MODES_LIST_SIZE; k++) {
        setting[k] = 0;
    }

    for(line = QUOTES_GREATER_THAN_LINE; line <= LEFTMOST_SALT_LINE; line += 1) {
        p = fgets(c, SMALL_BUFFER_SIZE, file);
        if(p == NULL) {
            break;
        }

        setting[line] = cstring_to_integer(c);
    }

    fclose(file);

    switch(setting[QUOTES_GREATER_THAN_LINE]) {
    case 0:
        vc->excludeQuotesGreaterThan = 0; /* FALSE */
        break;
    default:
        vc->excludeQuotesGreaterThan = TRUE;
        break;
    }

    switch(setting[MESSAGES_LINE]) {
    case 0:
        vc->removeVoyaError = 0; /* FALSE */
        break;
    default:
        vc->removeVoyaError = TRUE;
        break;
    }

    vc->displayMode = setting[DISPLAY_LINE];

    switch(setting[UTC_LINE]) {
    case 0:
        vc->universalTime = 0; /* FALSE */
        break;
    default:
        vc->universalTime = TRUE;
        break;
    }

    switch(setting[LEFTMOST_SALT_LINE]) {
    case 0:
        vc->leftmostSalt = 0; /* FALSE */
        break;
    default:
        vc->leftmostSalt = TRUE;
        break;
    }

    return TRUE;
}

BOOL repeating(void) {
    int i, k, measured;
    static int d;

/* Setting a list of repeated items */
    for(i = 0; i < bound; ++i) {
        measured = strlen(&c[i][0]);
        for(k = 0; k < w[i]; ++k) {
            strcpy(&character[d][0], &c[i][0]);
            width[d] = measured;
            if(++d >= EXTENDED_TABLE_SIZE) {
                return 0; /* FALSE */
            }
        }
    }

    return TRUE;
}

BOOL setByTriplet(int k, int m, int n) {
    BOOL* p;
    BOOL old;
/* 
hugeTable + k * HALF * HALF + m * HALF + n; 
m *= 128
k *= 16384
*/

    m <<= 7;
    k <<= 14;

    p = hugeTable + k + m + n;
    old = *p;
    *p = TRUE;
    return old;
}

BOOL threePlaces(int k, int m, int n) {
    BOOL* p;
/*
hugeTable + k * HALF * HALF + m * HALF + n;
m *= 128
k *= 16384
*/

    m <<= 7;
    k <<= 14;

    p = hugeTable + k + m + n;
    return *p;
}

BOOL voyaCtrlTextTouched(void) {
    BOOL touched;
    FILE *file;
    long file_time;

    switch(displayMode) {
    case DISPLAY_LATEST:
        showRing();
        break;
    case DISPLAY_TOTAL:
        newTotal();
        break;
    case LATEST_AND_TOTAL:
        showRing();
        newTotal();
        break;
    default:
        break;
    }

/* Checking if VOYA_CTRL_TEXT exists */
    file = fopen(VOYA_CTRL_TEXT, "rt");
    if(file == NULL) {
        touched = TRUE;
    } else {
        file_time = modified_file(VOYA_CTRL_TEXT);

/* Checking if VOYA_CTRL_TEXT has been modified */
        if(file_time == untouched) {
            touched = 0; /* FALSE */
        } else {
            touched = TRUE;
        }

        fclose(file);
    }

    return touched;
}

BOOL voyaLogBatchProcessing(void) {
    char *head;
    char *p;
    char *q;
    char *s;
    char *tail;
    char c[BUFFER_SIZE];
    char sublog[ITEM_COUNT][SMALL_BUFFER_SIZE];
    char voya_error[ITEM_COUNT][SMALL_BUFFER_SIZE];
    char voyaErrorName[ MAX_PATH + 1 ];
    const char DEL_COMMAND[] = "DEL ";
    const char REN_COMMAND[] = "REN ";
    const int DEL_COMMAND_SIZE = 4;
    const int GAP = ' ';
    const int PLUS = '+';
    const int PLUS_SIZE = 1;
    const int REN_COMMAND_SIZE = 4;
    const int TEMPORARY_SIZE = 4;
    FILE *batch;
    FILE *voyaError;
    FILE *voyaLog;
    int index = 0;
    int item = 0;
    int k;

    memset(sublog, 0, ITEM_COUNT * SMALL_BUFFER_SIZE );
    memset(voya_error, 0, ITEM_COUNT * SMALL_BUFFER_SIZE );

    batch = fopen(VOYA_LOG_BATCH, "rt");
    if(batch == NULL) {
        fprintf(stderr, "batch = fopen(VOYA_LOG_BATCH, \"rt\")");
        return 0; /* FALSE */
    }

    p = fgets(c, BUFFER_SIZE, batch);
    if(p != NULL) {
/* COPY line */
        q = strchr(c, PLUS);
        if(q != NULL) {
            q += PLUS_SIZE;
            tail = q;
            for(;;) {
                q = strchr(tail, PLUS);
                if(q != NULL) {
                    *q = '\0';
                    head = tail;
                    q += PLUS_SIZE;
                    tail = q;
                    q = & sublog[item][0];
                    item += 1;
                    strcpy(q, head);
                } else {
                    q = strchr(tail, GAP);
                    if(q != NULL) {
                        *q = '\0';
                        head = tail;
                        q = & sublog[item][0];
                        item += 1;
                        strcpy(q, head);
                    }

                    break;
                }

            } /* for(;;) */

        } else {
            fprintf(stderr, "q = strchr(c, PLUS)\n");
            return 0; /* FALSE */
        }

/* DEL lines */
        for(;;) {
            p = fgets(c, BUFFER_SIZE, batch);
            if(p == NULL) {
                break;
            }

            q = strstr(c, DEL_COMMAND);
            if(q != NULL) {
                q += DEL_COMMAND_SIZE;
                tail = q;
                q = strstr(tail, TEMPORARY);
                if(q != NULL) {
                    q += TEMPORARY_SIZE;
                    *q = '\0';
                    head = tail;
                    q = & voya_error[index][0];
                    index += 1;
                    strcpy(q, head);
                } else {
                    continue; /* voya.log line */
                }
            } else {
/* REN line */
                q = strstr(c, REN_COMMAND);
                if(q != NULL) {
                    q += REN_COMMAND_SIZE;
                    tail = q;
                    q = strstr(tail, TEMPORARY);
                    if(q != NULL) {
                        q += TEMPORARY_SIZE;
                        *q = '\0';
                        head = tail;
                        q = & voya_error[index][0];
                        index += 1;
                        strcpy(q, head);
                    } else {
                        fprintf(stderr, "q = strstr(tail, TEMPORARY)\n");
                        return 0; /* FALSE */
                    }

                } else {
                    fprintf(stderr, "q = strstr(c, REN_COMMAND)\n");
                    return 0; /* FALSE */
                }

                continue;
            }
        }

    } else {
        fprintf(stderr, "p = fgets(c, BUFFER_SIZE, batch)\n");
        return 0; /* FALSE */
    }

/* log file */
    voyaLog = fopen(vs->log_file_name, "at");
    if(voyaLog == NULL) {
        fprintf(stderr, "voyaLog = fopen(vs->log_file_name, \"at\")\n");
        return 0; /* FALSE */
    }

    for(k = 0; k < item; k++) {
        s = & sublog[k][0];
        strcpy(voyaErrorName, s);

/* open a sublog file */
        voyaError = fopen(voyaErrorName, "rt");
        if(voyaError == NULL) {
            fprintf(stderr, "voyaError = fopen(voyaErrorName, \"rt\")\n");
            return 0; /* FALSE */
        }

        for(;;) {
            p = fgets(c, BUFFER_SIZE, voyaError);
            if(p == NULL) {
                break;
            }

/* Adding sublog to the log */
            fputs(c, voyaLog);
        }

        fclose(voyaError);
    }

    fclose(voyaLog);

/* Deleting voya error files */
    for(k = 0; k < index; k++) {
        s = & voya_error[k][0];
        strcpy(voyaErrorName, s);
        remove(voyaErrorName);
    }

    return TRUE;
}

char *parameter_of_numbered(char *a, int *number) {
    char *stop;
    char numerical_sequence[INTEGER_SIZE];
    int non_number_length, span;
    int length = strlen(a);
    char *p = malloc( length + 1 );

// Copying all
    strcpy(p, a);
    span = strspn(strrev(p), "0123456789");
    non_number_length = length - span;

// Copying the second part of a
    memcpy(numerical_sequence, a + non_number_length, span);
    numerical_sequence[span] = '\0';
    *number = (int)strtol(numerical_sequence, &stop, 10);

// Copying the first part of a
    memcpy(p, a, non_number_length);
    p[non_number_length] = '\0';
    return p;
}

char random_ascii(char *ascii) {
    char single;
    static int stage;
    static unsigned long eight_bit_group[10];
    unsigned long bits;

    switch(stage) {
    case 1:
        single = ascii[ eight_bit_group[2] ];
        stage += 1;
        break;
    case 2:
        single = ascii[ eight_bit_group[1] ];
        stage += 1;
        break;
    case 3:
        single = ascii[ eight_bit_group[0] ];
        stage = 0;
        break;
    default:
        bits = genrand_int32();
        eight_bit_group[0] = bits & 0x000000FF;
        bits >>= 8;
        eight_bit_group[1] = bits & 0x000000FF;
        bits >>= 8;
        eight_bit_group[2] = bits & 0x000000FF;
        bits >>= 8;
        eight_bit_group[3] = bits & 0x000000FF;

        single = ascii[ eight_bit_group[3] ];
        stage = 1;
    }

    return single;
}

double shiftJisKanaAscii(void) {
    char *ascii;
    const int LOWER_BYTE = 0x00FF;
    int higher, i, lower, m, n;
    int d = 0;
    double sum = 0.0;

    for(i = 0x8140; i <= 0x81AC; ++i, ++d) { /*  */
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->parallel_weight;
        sum += (double)w[d];
    }

    for(i = 0x81B8; i <= 0x81BF; ++i, ++d) { /*  */
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->cap_weight;
        sum += (double)w[d];
    }

    for(i = 0x81C8; i <= 0x81CE; ++i, ++d) { /*  */
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->exists_weight;
        sum += (double)w[d];
    }

    for(i = 0x81DA; i <= 0x81E8; ++i, ++d) { /*  */
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->double_integral_weight;
        sum += (double)w[d];
    }

    for(i = 0x81F0; i <= 0x81F7; ++i, ++d) { /*  */
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->paragraph_weight;
        sum += (double)w[d];
    }

    m = 0x81FC; /*  */
    lower = m & LOWER_BYTE;
    higher = m >> 8;
    c[d][0] = higher;
    c[d][1] = lower;
    c[d][2] = '\0';
    w[d] = vs->circle_weight;
    sum += (double)w[d];
    d++;

    for(i = 0x824F; i <= 0x8258; ++i, ++d) { /* X */
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->nine_weight;
        sum += (double)w[d];
    }

    for(i = 0x8260; i <= 0x8279; ++i, ++d) { /* y */
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->capital_z_weight;
        sum += (double)w[d];
    }

    for(i = 0x8281; i <= 0x829A; ++i, ++d) { /*  */
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->z_weight;
        sum += (double)w[d];
    }

    for(i = 0x829F; i <= 0x82F1; ++i, ++d) { /*  */
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->hiragana_weight;
        sum += (double)w[d];
    }

    for(i = 0x8340; i <= 0x8396; ++i, ++d) { /*  */
        if(i == 0x837F) {
            continue;
        }

        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->katakana_weight;
        sum += (double)w[d];
    }

    for(i = 0x839F; i <= 0x83B6; ++i, ++d) { /*  */
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->capital_omega_weight;
        sum += (double)w[d];
    }

    for(i = 0x83BF; i <= 0x83D6; ++i, ++d) { /*  */
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->omega_weight;
        sum += (double)w[d];
    }

    for(i = 0x8440; i <= 0x8460; ++i, ++d) { /* ` */
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->capital_ya_weight;
        sum += (double)w[d];
    }

    for(i = 0x8470; i <= 0x8491; ++i) { /*  */
        lower = i & LOWER_BYTE;
        if(lower == 0x7F) {
            continue;
        }

        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->ya_weight;
        sum += (double)w[d];
        d++;
    }

    for(i = 0x849F; i <= 0x84BE; ++i, ++d) { /*  */
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->keisen_weight;
        sum += (double)w[d];
    }

    for(i = 0x8740; i <= 0x875D; ++i, ++d) { /* ] */
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->roman_weight;
        sum += (double)w[d];
    }

    for(i = 0x875F; i <= 0x8775; ++i, ++d) { /* u */
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->square_meter_weight;
        sum += (double)w[d];
    }

    n = 0x877E; /* ~ */
    lower = n & LOWER_BYTE;
    higher = n >> 8;
    c[d][0] = higher;
    c[d][1] = lower;
    c[d][2] = '\0';
    w[d] = vs->heisei_weight;
    sum += (double)w[d];
    d++;

    for(i = 0x8780; i <= 0x879C; ++i, ++d) { /*  */
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->cup_weight;
        sum += (double)w[d];
    }

    for(i = 0x889F; i <= 0x88FC; ++i, ++d) { /* JIS level-1 kanji set starts idling 0x889F (  ) */
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->jis_level_one_kanji_weight;
        sum += (double)w[d];
    }

    for(i = 0x8940; i <= 0x9FFC; ++i) {
        if(0x9873 <=i && i <= 0x989E) { /* JIS level-2 kanji set starts idling 0x989F (  ) */
            continue;
        }

        lower = i & LOWER_BYTE;
        if(lower < 0x40) {
            continue;
        } else if(lower == 0x7F) {
            continue;
        } else if(0xFD <= lower) {
            continue;
        }

        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->jis_level_two_kanji_weight;
        sum += (double)w[d];
        d++;
    }

    for(i = 0xE040; i <= 0xE9FC; ++i) {
        lower = i & LOWER_BYTE;
        if(lower < 0x40) {
            continue;
        } else if(lower == 0x7F) {
            continue;
        } else if(0xFD <= lower) {
            continue;
        }

        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->jis_level_two_kanji_weight;
        sum += (double)w[d];
        d++;
    }

    for(i = 0xEA40; i <= 0xEAA4; ++i) {
        lower = i & LOWER_BYTE;
        if(lower == 0x7F) {
            continue;
        }

        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->jis_level_two_kanji_weight;
        sum += (double)w[d];
        d++;
    }

    for(i = 0xED40; i <= 0xEDFC; ++i) {
        lower = i & LOWER_BYTE;
        if(lower == 0x7F) {
            continue;
        }

        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->jis_level_two_kanji_weight;
        sum += (double)w[d];
        d++;
    }

    for(i = 0xEE40; i <= 0xEEEC; ++i) {
        lower = i & LOWER_BYTE;
        if(lower == 0x7F) {
            continue;
        }

        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->jis_level_two_kanji_weight;
        sum += (double)w[d];
        d++;
    }

    for(i = 0xEEEF; i <= 0xEEFC; ++i, ++d) {
        lower = i & LOWER_BYTE;
        higher = i >> 8;
        c[d][0] = higher;
        c[d][1] = lower;
        c[d][2] = '\0';
        w[d] = vs->jis_level_two_kanji_weight;
        sum += (double)w[d];
    }

/* hankaku katakana */
    for(i = 0xA1; i <= 0xDF; ++i, ++d) { /*  */
        c[d][0] = i;
        c[d][1] = '\0';
        c[d][2] = '\0';
        w[d] = vs->hankaku_katakana_weight;
        sum += (double)w[d];
    }

/* ASCII */
    if(vc->excludeQuotesGreaterThan) {
/* 
Excluding five symbols: " ' > < & 
*/
        ascii = &ascii_subset[0];
    } else {
        ascii = &ascii_set[0];
    }

    for(i = 0; i < ASCII_COUNT; ++i, ++d) { /*  !"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`abcdefghijklmnopqrstuvwxyz{|}~ */
        c[d][0] = ascii[i];
        c[d][1] = '\0';
        c[d][2] = '\0';
        w[d] = vs->ascii_weight;
        sum += (double)w[d];
    }

    bound = d;
    return sum;
}

int non_seeker(void) {
    char *p;
    char buffer[BUFFER_SIZE];
    char dayOfWeek[7][4] = {"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"};
    CRYPT crypt;
    HMODULE cryptGNU;
    int dd, h, m, mm, sec, wd, y;
    int request_length;
    struct tm *systemTime;
    time_t since1970;
    time_t * timer = &since1970;

/* request */
    if( settingBy(VOYA_CSV) ){
        readLabels();
        request_length = strlen(vs->request);
        if( request_length < 1 ) {
            voyaMessageFlush("request_length < 1");
            closeVoyaError();
            return REQUEST_LENGTH_ERROR;
        }

    } else {
        voyaMessageFlush("settingBy(VOYA_CSV)");
        closeVoyaError();
        return VOYA_CSV_ERROR;
    }

/* positive numbers */
    if(vs->idling < 0) {
        voyaMessageFlush("vs->idling < 0");
        closeVoyaError();
        return IDLING_ERROR;
    }

    if(vs->interim_report < 1) {
        voyaMessageFlush("vs->interim_report < 1");
        closeVoyaError();
        return INTERIM_REPORT_ERROR;
    }

/* Getting time information */
    time(timer);
    if(universalTime) { /* UTC or GMT */
        systemTime = gmtime(timer);
    } else {
        systemTime = localtime(timer);
    }

    dd = systemTime->tm_mday;
    h = systemTime->tm_hour;
    m = systemTime->tm_min;
    mm = systemTime->tm_mon + 1;
    sec = systemTime->tm_sec;
    wd = systemTime->tm_wday;
    y = systemTime->tm_year + 1900;

    p = &dayOfWeek[wd][0];
    sprintf(buffer, "%04d-%02d-%02d(%s) %02d:%02d:%02d", y, mm, dd, p, h, m, sec);

    if(universalTime) {
        strcat(buffer, " GMT");
    }

    strcat(buffer, NON_TORI_LINE);
    voyaMessageFlush(buffer);

/* GNU crypt.dll */
    cryptGNU = LoadLibrary("crypt.dll");
    if(cryptGNU == NULL) {
        voyaMessageFlush("cryptGNU == NULL");
        closeVoyaError();
        return CRYPT_DLL_ERROR;
    }

    crypt = (CRYPT) GetProcAddress(cryptGNU, "crypt");
    if(crypt == NULL) {
        voyaMessageFlush("crypt == NULL");
        closeVoyaError();
        return GET_PROC_ADDRESS_ERROR;
    }

    FreeLibrary(cryptGNU);
    closeVoyaError();
    return 0;
}

int seekerAsDragonSeek(void) {
    char *body;
    char *b;
    char *p;
    char *q;
    char buffer[SMALL_BUFFER_SIZE];
    char h[256][3];
    char head[4][2];
    char matched[SMALL_BUFFER_SIZE];
    char pass[ CHARACTER_COUNT + 2 ];
    char quartet[4][SMALL_BUFFER_SIZE];
    char request[REQUEST_SIZE];
    char tail[4][2];
    const BOOL BREAK = 0; /* FALSE */
    int c, idling, interim_report, k, request_length, s, u;
    int count = 0;
    int efforts = 0;
    unsigned long d;
    CRYPT crypt;
    HMODULE cryptGNU;
    double sum;

/* request */
    if( settingBy(VOYA_CSV) ){
        readLabels();
        request_length = strlen(vs->request);
        if( request_length < 1 ) {
            voyaMessageFlush("request_length < 1");
            closeVoyaError();
            return REQUEST_LENGTH_ERROR;
        } else {
            strcpy(request, vs->request);
        }

    } else {
        voyaMessageFlush("settingBy(VOYA_CSV)");
        closeVoyaError();
        return VOYA_CSV_ERROR;
    }

/* positive numbers */
    idling = vs->idling;
    if(idling < 0) {
        voyaMessageFlush("idling < 0");
        closeVoyaError();
        return IDLING_ERROR;
    }

    interim_report = vs->interim_report;
    if(interim_report < 1) {
        voyaMessageFlush("interim_report < 1");
        closeVoyaError();
        return INTERIM_REPORT_ERROR;
    }

/* GNU crypt.dll */
    cryptGNU = LoadLibrary("crypt.dll");
    crypt = (CRYPT) GetProcAddress(cryptGNU, "crypt");

/* hexadecimal */
    strcpy(&h[  0][0], "00"); strcpy(&h[  1][0], "01"); strcpy(&h[  2][0], "02"); strcpy(&h[  3][0], "03"); strcpy(&h[  4][0], "04"); strcpy(&h[  5][0], "05"); strcpy(&h[  6][0], "06"); strcpy(&h[  7][0], "07"); strcpy(&h[  8][0], "08"); strcpy(&h[  9][0], "09"); strcpy(&h[ 10][0], "0A"); strcpy(&h[ 11][0], "0B");
    strcpy(&h[ 12][0], "0C"); strcpy(&h[ 13][0], "0D"); strcpy(&h[ 14][0], "0E"); strcpy(&h[ 15][0], "0F"); strcpy(&h[ 16][0], "10"); strcpy(&h[ 17][0], "11"); strcpy(&h[ 18][0], "12"); strcpy(&h[ 19][0], "13"); strcpy(&h[ 20][0], "14"); strcpy(&h[ 21][0], "15"); strcpy(&h[ 22][0], "16"); strcpy(&h[ 23][0], "17");
    strcpy(&h[ 24][0], "18"); strcpy(&h[ 25][0], "19"); strcpy(&h[ 26][0], "1A"); strcpy(&h[ 27][0], "1B"); strcpy(&h[ 28][0], "1C"); strcpy(&h[ 29][0], "1D"); strcpy(&h[ 30][0], "1E"); strcpy(&h[ 31][0], "1F"); strcpy(&h[ 32][0], "20"); strcpy(&h[ 33][0], "21"); strcpy(&h[ 34][0], "22"); strcpy(&h[ 35][0], "23");
    strcpy(&h[ 36][0], "24"); strcpy(&h[ 37][0], "25"); strcpy(&h[ 38][0], "26"); strcpy(&h[ 39][0], "27"); strcpy(&h[ 40][0], "28"); strcpy(&h[ 41][0], "29"); strcpy(&h[ 42][0], "2A"); strcpy(&h[ 43][0], "2B"); strcpy(&h[ 44][0], "2C"); strcpy(&h[ 45][0], "2D"); strcpy(&h[ 46][0], "2E"); strcpy(&h[ 47][0], "2F");
    strcpy(&h[ 48][0], "30"); strcpy(&h[ 49][0], "31"); strcpy(&h[ 50][0], "32"); strcpy(&h[ 51][0], "33"); strcpy(&h[ 52][0], "34"); strcpy(&h[ 53][0], "35"); strcpy(&h[ 54][0], "36"); strcpy(&h[ 55][0], "37"); strcpy(&h[ 56][0], "38"); strcpy(&h[ 57][0], "39"); strcpy(&h[ 58][0], "3A"); strcpy(&h[ 59][0], "3B");
    strcpy(&h[ 60][0], "3C"); strcpy(&h[ 61][0], "3D"); strcpy(&h[ 62][0], "3E"); strcpy(&h[ 63][0], "3F"); strcpy(&h[ 64][0], "40"); strcpy(&h[ 65][0], "41"); strcpy(&h[ 66][0], "42"); strcpy(&h[ 67][0], "43"); strcpy(&h[ 68][0], "44"); strcpy(&h[ 69][0], "45"); strcpy(&h[ 70][0], "46"); strcpy(&h[ 71][0], "47");
    strcpy(&h[ 72][0], "48"); strcpy(&h[ 73][0], "49"); strcpy(&h[ 74][0], "4A"); strcpy(&h[ 75][0], "4B"); strcpy(&h[ 76][0], "4C"); strcpy(&h[ 77][0], "4D"); strcpy(&h[ 78][0], "4E"); strcpy(&h[ 79][0], "4F"); strcpy(&h[ 80][0], "50"); strcpy(&h[ 81][0], "51"); strcpy(&h[ 82][0], "52"); strcpy(&h[ 83][0], "53");
    strcpy(&h[ 84][0], "54"); strcpy(&h[ 85][0], "55"); strcpy(&h[ 86][0], "56"); strcpy(&h[ 87][0], "57"); strcpy(&h[ 88][0], "58"); strcpy(&h[ 89][0], "59"); strcpy(&h[ 90][0], "5A"); strcpy(&h[ 91][0], "5B"); strcpy(&h[ 92][0], "5C"); strcpy(&h[ 93][0], "5D"); strcpy(&h[ 94][0], "5E"); strcpy(&h[ 95][0], "5F");
    strcpy(&h[ 96][0], "60"); strcpy(&h[ 97][0], "61"); strcpy(&h[ 98][0], "62"); strcpy(&h[ 99][0], "63"); strcpy(&h[100][0], "64"); strcpy(&h[101][0], "65"); strcpy(&h[102][0], "66"); strcpy(&h[103][0], "67"); strcpy(&h[104][0], "68"); strcpy(&h[105][0], "69"); strcpy(&h[106][0], "6A"); strcpy(&h[107][0], "6B");
    strcpy(&h[108][0], "6C"); strcpy(&h[109][0], "6D"); strcpy(&h[110][0], "6E"); strcpy(&h[111][0], "6F"); strcpy(&h[112][0], "70"); strcpy(&h[113][0], "71"); strcpy(&h[114][0], "72"); strcpy(&h[115][0], "73"); strcpy(&h[116][0], "74"); strcpy(&h[117][0], "75"); strcpy(&h[118][0], "76"); strcpy(&h[119][0], "77");
    strcpy(&h[120][0], "78"); strcpy(&h[121][0], "79"); strcpy(&h[122][0], "7A"); strcpy(&h[123][0], "7B"); strcpy(&h[124][0], "7C"); strcpy(&h[125][0], "7D"); strcpy(&h[126][0], "7E"); strcpy(&h[127][0], "7F"); strcpy(&h[128][0], "80"); strcpy(&h[129][0], "81"); strcpy(&h[130][0], "82"); strcpy(&h[131][0], "83");
    strcpy(&h[132][0], "84"); strcpy(&h[133][0], "85"); strcpy(&h[134][0], "86"); strcpy(&h[135][0], "87"); strcpy(&h[136][0], "88"); strcpy(&h[137][0], "89"); strcpy(&h[138][0], "8A"); strcpy(&h[139][0], "8B"); strcpy(&h[140][0], "8C"); strcpy(&h[141][0], "8D"); strcpy(&h[142][0], "8E"); strcpy(&h[143][0], "8F");
    strcpy(&h[144][0], "90"); strcpy(&h[145][0], "91"); strcpy(&h[146][0], "92"); strcpy(&h[147][0], "93"); strcpy(&h[148][0], "94"); strcpy(&h[149][0], "95"); strcpy(&h[150][0], "96"); strcpy(&h[151][0], "97"); strcpy(&h[152][0], "98"); strcpy(&h[153][0], "99"); strcpy(&h[154][0], "9A"); strcpy(&h[155][0], "9B");
    strcpy(&h[156][0], "9C"); strcpy(&h[157][0], "9D"); strcpy(&h[158][0], "9E"); strcpy(&h[159][0], "9F"); strcpy(&h[160][0], "A0"); strcpy(&h[161][0], "A1"); strcpy(&h[162][0], "A2"); strcpy(&h[163][0], "A3"); strcpy(&h[164][0], "A4"); strcpy(&h[165][0], "A5"); strcpy(&h[166][0], "A6"); strcpy(&h[167][0], "A7");
    strcpy(&h[168][0], "A8"); strcpy(&h[169][0], "A9"); strcpy(&h[170][0], "AA"); strcpy(&h[171][0], "AB"); strcpy(&h[172][0], "AC"); strcpy(&h[173][0], "AD"); strcpy(&h[174][0], "AE"); strcpy(&h[175][0], "AF"); strcpy(&h[176][0], "B0"); strcpy(&h[177][0], "B1"); strcpy(&h[178][0], "B2"); strcpy(&h[179][0], "B3");
    strcpy(&h[180][0], "B4"); strcpy(&h[181][0], "B5"); strcpy(&h[182][0], "B6"); strcpy(&h[183][0], "B7"); strcpy(&h[184][0], "B8"); strcpy(&h[185][0], "B9"); strcpy(&h[186][0], "BA"); strcpy(&h[187][0], "BB"); strcpy(&h[188][0], "BC"); strcpy(&h[189][0], "BD"); strcpy(&h[190][0], "BE"); strcpy(&h[191][0], "BF");
    strcpy(&h[192][0], "C0"); strcpy(&h[193][0], "C1"); strcpy(&h[194][0], "C2"); strcpy(&h[195][0], "C3"); strcpy(&h[196][0], "C4"); strcpy(&h[197][0], "C5"); strcpy(&h[198][0], "C6"); strcpy(&h[199][0], "C7"); strcpy(&h[200][0], "C8"); strcpy(&h[201][0], "C9"); strcpy(&h[202][0], "CA"); strcpy(&h[203][0], "CB");
    strcpy(&h[204][0], "CC"); strcpy(&h[205][0], "CD"); strcpy(&h[206][0], "CE"); strcpy(&h[207][0], "CF"); strcpy(&h[208][0], "D0"); strcpy(&h[209][0], "D1"); strcpy(&h[210][0], "D2"); strcpy(&h[211][0], "D3"); strcpy(&h[212][0], "D4"); strcpy(&h[213][0], "D5"); strcpy(&h[214][0], "D6"); strcpy(&h[215][0], "D7");
    strcpy(&h[216][0], "D8"); strcpy(&h[217][0], "D9"); strcpy(&h[218][0], "DA"); strcpy(&h[219][0], "DB"); strcpy(&h[220][0], "DC"); strcpy(&h[221][0], "DD"); strcpy(&h[222][0], "DE"); strcpy(&h[223][0], "DF"); strcpy(&h[224][0], "E0"); strcpy(&h[225][0], "E1"); strcpy(&h[226][0], "E2"); strcpy(&h[227][0], "E3");
    strcpy(&h[228][0], "E4"); strcpy(&h[229][0], "E5"); strcpy(&h[230][0], "E6"); strcpy(&h[231][0], "E7"); strcpy(&h[232][0], "E8"); strcpy(&h[233][0], "E9"); strcpy(&h[234][0], "EA"); strcpy(&h[235][0], "EB"); strcpy(&h[236][0], "EC"); strcpy(&h[237][0], "ED"); strcpy(&h[238][0], "EE"); strcpy(&h[239][0], "EF");
    strcpy(&h[240][0], "F0"); strcpy(&h[241][0], "F1"); strcpy(&h[242][0], "F2"); strcpy(&h[243][0], "F3"); strcpy(&h[244][0], "F4"); strcpy(&h[245][0], "F5"); strcpy(&h[246][0], "F6"); strcpy(&h[247][0], "F7"); strcpy(&h[248][0], "F8"); strcpy(&h[249][0], "F9"); strcpy(&h[250][0], "FA"); strcpy(&h[251][0], "FB");
    strcpy(&h[252][0], "FC"); strcpy(&h[253][0], "FD"); strcpy(&h[254][0], "FE"); strcpy(&h[255][0], "FF");

/* request */
    u = strlen(request);

/* 
012345678901
^[Rr]uda[/.]
*/
    head[0][0] = request[2];
    head[0][1] = '\0';
    tail[0][0] = request[ u - 3 ];
    tail[0][1] = '\0';

    head[1][0] = request[2];
    head[1][1] = '\0';
    tail[1][0] = request[ u - 2 ];
    tail[1][1] = '\0';

    head[2][0] = request[3];
    head[2][1] = '\0';
    tail[2][0] = request[ u - 3 ];
    tail[2][1] = '\0';

    head[3][0] = request[3];
    head[3][1] = '\0';
    tail[3][0] = request[ u - 2 ];
    tail[3][1] = '\0';

    request[ u - 4 ] = '\0';
    for(k = 0; k < 4; k++) {
        q = & quartet[k][0];
        body = & request[5];

        strcpy(q, &head[k][0]);
        strcat(q, body);
        strcat(q, &tail[k][0]);
    }

/* Setting a list of repeated items */
    sum = shiftJisKanaAscii();

    switch( sumOfWeight(sum) ) {
    case -1:
        voyaMessage(TOO_LARGE_SUM);
        voyaSumFlush(sum);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    case 0:
        voyaMessageFlush(SUM_EQUALS_ZERO);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    }

    while( repeating() ){}

/* Setting Mersenne Twister (MT) */
    setMT(TIME_USED_AS_SEED, idling);

    makeBatchFile();
    while(! terminated) {
        efforts += 1;
        if(efforts == interim_report) {
            if( voyaCtrlTextTouched() ) {
                break;
            }

            efforts = 0;
        }

/* Generating random numbers to produce a key */
        pass[0] = '\0';
        s = 0;
        while(s < CHARACTER_COUNT) { /* s may not equal 8 or 9. */
            d = randomIndex();
            strcat(pass, &character[d][0]);
            s += width[d];
        }

/* Encrypting to produce a tori */
        pass[CHARACTER_COUNT] = '\0';
        q = crypt(pass, "..");
        s = strlen(q) - TEN_FIGURE_TORI;

        p = &q[s]; /* tori */

/* 
^[hH]body[tT]
head: h or H
body: fixed string
tail: t or T

^[Rr]uda[/.], for example.
*/
        do {
            b = strstr(p, quartet[0]);
            if(b != NULL) {
                break;
            }

            b = strstr(p, quartet[1]);
            if(b != NULL) {
                break;
            }

            b = strstr(p, quartet[2]);
            if(b != NULL) {
                break;
            }

            b = strstr(p, quartet[3]);
            if(b != NULL) {
                break;
            }

        } while(BREAK);

        if(b == NULL) {
            continue;
        } else if(b != p) {
            continue;
        }

        strcpy(matched, p); /* tori */
        count += 1;

/* Expressing the key as hexadecimal */
        buffer[0] = '\0';
        q = &pass[0];
        while(*q != '\0') {
            c = charToInteger(*q);
            strcat(buffer, &h[c][0]); /* hexadecimal */
            ++q;
        }

        strcat(buffer, FROM_TO);
        strcat(buffer, matched);
        voyaMessageFlush(buffer);

        sprintf(buffer, "%s%d | %s", TOTAL_COLON, count, matched);
        pop_front();
        push_back(buffer);
    }

    FreeLibrary(cryptGNU);
    closeVoyaError();
    return 0;
}

int seekerAsLeftmostSalt(void) {
    BOOL case_sensitive;
    char *ascii_array;
    char *b;
    char *q;
    char *salt;
    char *salt_array;
    char buffer[SMALL_BUFFER_SIZE];
    char h[256][3];
    char matched[SMALL_BUFFER_SIZE];
    char pass[ CHARACTER_COUNT + 2 ];
    char request[REQUEST_SIZE];
    CRYPT crypt;
    double sum;
    HMODULE cryptGNU;
    int c, idling, interim_report, k, s;
    int count = 0;
    int efforts = 0;
    int request_length;
    unsigned long d;

/* request */
    if( settingBy(VOYA_CSV) ){
        readLabels();
        request_length = strlen(vs->request);
        if( request_length < 1 ) {
            voyaMessageFlush("request_length < 1");
            closeVoyaError();
            return REQUEST_LENGTH_ERROR;
        } else {
            strcpy(request, vs->request);
        }

    } else {
        voyaMessageFlush("settingBy(VOYA_CSV)");
        closeVoyaError();
        return VOYA_CSV_ERROR;
    }

/* positive numbers */
    idling = vs->idling;
    if(idling < 0) {
        voyaMessageFlush("idling < 0");
        closeVoyaError();
        return IDLING_ERROR;
    }

    interim_report = vs->interim_report;
    if(interim_report < 1) {
        voyaMessageFlush("interim_report < 1");
        closeVoyaError();
        return INTERIM_REPORT_ERROR;
    }

/* GNU crypt.dll */
    cryptGNU = LoadLibrary("crypt.dll");
    crypt = (CRYPT) GetProcAddress(cryptGNU, "crypt");

/* Huge table set by triplet so that threePlaces() can read boolean values */
    hugeTable = (BOOL *)malloc( HALF * HALF * HALF * sizeof(BOOL) );
    if(hugeTable == NULL) {
        voyaMessageFlush("hugeTable == NULL");
        FreeLibrary(cryptGNU);
        closeVoyaError();
        return BOOL_MALLOC_ERROR;
    }

    memset(hugeTable, 0, HALF * HALF * HALF * sizeof(BOOL) );

/* hexadecimal */
    strcpy(&h[  0][0], "00"); strcpy(&h[  1][0], "01"); strcpy(&h[  2][0], "02"); strcpy(&h[  3][0], "03"); strcpy(&h[  4][0], "04"); strcpy(&h[  5][0], "05"); strcpy(&h[  6][0], "06"); strcpy(&h[  7][0], "07"); strcpy(&h[  8][0], "08"); strcpy(&h[  9][0], "09"); strcpy(&h[ 10][0], "0A"); strcpy(&h[ 11][0], "0B");
    strcpy(&h[ 12][0], "0C"); strcpy(&h[ 13][0], "0D"); strcpy(&h[ 14][0], "0E"); strcpy(&h[ 15][0], "0F"); strcpy(&h[ 16][0], "10"); strcpy(&h[ 17][0], "11"); strcpy(&h[ 18][0], "12"); strcpy(&h[ 19][0], "13"); strcpy(&h[ 20][0], "14"); strcpy(&h[ 21][0], "15"); strcpy(&h[ 22][0], "16"); strcpy(&h[ 23][0], "17");
    strcpy(&h[ 24][0], "18"); strcpy(&h[ 25][0], "19"); strcpy(&h[ 26][0], "1A"); strcpy(&h[ 27][0], "1B"); strcpy(&h[ 28][0], "1C"); strcpy(&h[ 29][0], "1D"); strcpy(&h[ 30][0], "1E"); strcpy(&h[ 31][0], "1F"); strcpy(&h[ 32][0], "20"); strcpy(&h[ 33][0], "21"); strcpy(&h[ 34][0], "22"); strcpy(&h[ 35][0], "23");
    strcpy(&h[ 36][0], "24"); strcpy(&h[ 37][0], "25"); strcpy(&h[ 38][0], "26"); strcpy(&h[ 39][0], "27"); strcpy(&h[ 40][0], "28"); strcpy(&h[ 41][0], "29"); strcpy(&h[ 42][0], "2A"); strcpy(&h[ 43][0], "2B"); strcpy(&h[ 44][0], "2C"); strcpy(&h[ 45][0], "2D"); strcpy(&h[ 46][0], "2E"); strcpy(&h[ 47][0], "2F");
    strcpy(&h[ 48][0], "30"); strcpy(&h[ 49][0], "31"); strcpy(&h[ 50][0], "32"); strcpy(&h[ 51][0], "33"); strcpy(&h[ 52][0], "34"); strcpy(&h[ 53][0], "35"); strcpy(&h[ 54][0], "36"); strcpy(&h[ 55][0], "37"); strcpy(&h[ 56][0], "38"); strcpy(&h[ 57][0], "39"); strcpy(&h[ 58][0], "3A"); strcpy(&h[ 59][0], "3B");
    strcpy(&h[ 60][0], "3C"); strcpy(&h[ 61][0], "3D"); strcpy(&h[ 62][0], "3E"); strcpy(&h[ 63][0], "3F"); strcpy(&h[ 64][0], "40"); strcpy(&h[ 65][0], "41"); strcpy(&h[ 66][0], "42"); strcpy(&h[ 67][0], "43"); strcpy(&h[ 68][0], "44"); strcpy(&h[ 69][0], "45"); strcpy(&h[ 70][0], "46"); strcpy(&h[ 71][0], "47");
    strcpy(&h[ 72][0], "48"); strcpy(&h[ 73][0], "49"); strcpy(&h[ 74][0], "4A"); strcpy(&h[ 75][0], "4B"); strcpy(&h[ 76][0], "4C"); strcpy(&h[ 77][0], "4D"); strcpy(&h[ 78][0], "4E"); strcpy(&h[ 79][0], "4F"); strcpy(&h[ 80][0], "50"); strcpy(&h[ 81][0], "51"); strcpy(&h[ 82][0], "52"); strcpy(&h[ 83][0], "53");
    strcpy(&h[ 84][0], "54"); strcpy(&h[ 85][0], "55"); strcpy(&h[ 86][0], "56"); strcpy(&h[ 87][0], "57"); strcpy(&h[ 88][0], "58"); strcpy(&h[ 89][0], "59"); strcpy(&h[ 90][0], "5A"); strcpy(&h[ 91][0], "5B"); strcpy(&h[ 92][0], "5C"); strcpy(&h[ 93][0], "5D"); strcpy(&h[ 94][0], "5E"); strcpy(&h[ 95][0], "5F");
    strcpy(&h[ 96][0], "60"); strcpy(&h[ 97][0], "61"); strcpy(&h[ 98][0], "62"); strcpy(&h[ 99][0], "63"); strcpy(&h[100][0], "64"); strcpy(&h[101][0], "65"); strcpy(&h[102][0], "66"); strcpy(&h[103][0], "67"); strcpy(&h[104][0], "68"); strcpy(&h[105][0], "69"); strcpy(&h[106][0], "6A"); strcpy(&h[107][0], "6B");
    strcpy(&h[108][0], "6C"); strcpy(&h[109][0], "6D"); strcpy(&h[110][0], "6E"); strcpy(&h[111][0], "6F"); strcpy(&h[112][0], "70"); strcpy(&h[113][0], "71"); strcpy(&h[114][0], "72"); strcpy(&h[115][0], "73"); strcpy(&h[116][0], "74"); strcpy(&h[117][0], "75"); strcpy(&h[118][0], "76"); strcpy(&h[119][0], "77");
    strcpy(&h[120][0], "78"); strcpy(&h[121][0], "79"); strcpy(&h[122][0], "7A"); strcpy(&h[123][0], "7B"); strcpy(&h[124][0], "7C"); strcpy(&h[125][0], "7D"); strcpy(&h[126][0], "7E"); strcpy(&h[127][0], "7F"); strcpy(&h[128][0], "80"); strcpy(&h[129][0], "81"); strcpy(&h[130][0], "82"); strcpy(&h[131][0], "83");
    strcpy(&h[132][0], "84"); strcpy(&h[133][0], "85"); strcpy(&h[134][0], "86"); strcpy(&h[135][0], "87"); strcpy(&h[136][0], "88"); strcpy(&h[137][0], "89"); strcpy(&h[138][0], "8A"); strcpy(&h[139][0], "8B"); strcpy(&h[140][0], "8C"); strcpy(&h[141][0], "8D"); strcpy(&h[142][0], "8E"); strcpy(&h[143][0], "8F");
    strcpy(&h[144][0], "90"); strcpy(&h[145][0], "91"); strcpy(&h[146][0], "92"); strcpy(&h[147][0], "93"); strcpy(&h[148][0], "94"); strcpy(&h[149][0], "95"); strcpy(&h[150][0], "96"); strcpy(&h[151][0], "97"); strcpy(&h[152][0], "98"); strcpy(&h[153][0], "99"); strcpy(&h[154][0], "9A"); strcpy(&h[155][0], "9B");
    strcpy(&h[156][0], "9C"); strcpy(&h[157][0], "9D"); strcpy(&h[158][0], "9E"); strcpy(&h[159][0], "9F"); strcpy(&h[160][0], "A0"); strcpy(&h[161][0], "A1"); strcpy(&h[162][0], "A2"); strcpy(&h[163][0], "A3"); strcpy(&h[164][0], "A4"); strcpy(&h[165][0], "A5"); strcpy(&h[166][0], "A6"); strcpy(&h[167][0], "A7");
    strcpy(&h[168][0], "A8"); strcpy(&h[169][0], "A9"); strcpy(&h[170][0], "AA"); strcpy(&h[171][0], "AB"); strcpy(&h[172][0], "AC"); strcpy(&h[173][0], "AD"); strcpy(&h[174][0], "AE"); strcpy(&h[175][0], "AF"); strcpy(&h[176][0], "B0"); strcpy(&h[177][0], "B1"); strcpy(&h[178][0], "B2"); strcpy(&h[179][0], "B3");
    strcpy(&h[180][0], "B4"); strcpy(&h[181][0], "B5"); strcpy(&h[182][0], "B6"); strcpy(&h[183][0], "B7"); strcpy(&h[184][0], "B8"); strcpy(&h[185][0], "B9"); strcpy(&h[186][0], "BA"); strcpy(&h[187][0], "BB"); strcpy(&h[188][0], "BC"); strcpy(&h[189][0], "BD"); strcpy(&h[190][0], "BE"); strcpy(&h[191][0], "BF");
    strcpy(&h[192][0], "C0"); strcpy(&h[193][0], "C1"); strcpy(&h[194][0], "C2"); strcpy(&h[195][0], "C3"); strcpy(&h[196][0], "C4"); strcpy(&h[197][0], "C5"); strcpy(&h[198][0], "C6"); strcpy(&h[199][0], "C7"); strcpy(&h[200][0], "C8"); strcpy(&h[201][0], "C9"); strcpy(&h[202][0], "CA"); strcpy(&h[203][0], "CB");
    strcpy(&h[204][0], "CC"); strcpy(&h[205][0], "CD"); strcpy(&h[206][0], "CE"); strcpy(&h[207][0], "CF"); strcpy(&h[208][0], "D0"); strcpy(&h[209][0], "D1"); strcpy(&h[210][0], "D2"); strcpy(&h[211][0], "D3"); strcpy(&h[212][0], "D4"); strcpy(&h[213][0], "D5"); strcpy(&h[214][0], "D6"); strcpy(&h[215][0], "D7");
    strcpy(&h[216][0], "D8"); strcpy(&h[217][0], "D9"); strcpy(&h[218][0], "DA"); strcpy(&h[219][0], "DB"); strcpy(&h[220][0], "DC"); strcpy(&h[221][0], "DD"); strcpy(&h[222][0], "DE"); strcpy(&h[223][0], "DF"); strcpy(&h[224][0], "E0"); strcpy(&h[225][0], "E1"); strcpy(&h[226][0], "E2"); strcpy(&h[227][0], "E3");
    strcpy(&h[228][0], "E4"); strcpy(&h[229][0], "E5"); strcpy(&h[230][0], "E6"); strcpy(&h[231][0], "E7"); strcpy(&h[232][0], "E8"); strcpy(&h[233][0], "E9"); strcpy(&h[234][0], "EA"); strcpy(&h[235][0], "EB"); strcpy(&h[236][0], "EC"); strcpy(&h[237][0], "ED"); strcpy(&h[238][0], "EE"); strcpy(&h[239][0], "EF");
    strcpy(&h[240][0], "F0"); strcpy(&h[241][0], "F1"); strcpy(&h[242][0], "F2"); strcpy(&h[243][0], "F3"); strcpy(&h[244][0], "F4"); strcpy(&h[245][0], "F5"); strcpy(&h[246][0], "F6"); strcpy(&h[247][0], "F7"); strcpy(&h[248][0], "F8"); strcpy(&h[249][0], "F9"); strcpy(&h[250][0], "FA"); strcpy(&h[251][0], "FB");
    strcpy(&h[252][0], "FC"); strcpy(&h[253][0], "FD"); strcpy(&h[254][0], "FE"); strcpy(&h[255][0], "FF");

/* request */
    request_length = strlen(request);
    if(request_length < 3) {
        strcat(request, COMPLEMENT);
        request[3] = '\0';
    }

    case_sensitive = vs->case_sensitive;
    if(case_sensitive) {
        setByTriplet(request[0], request[1], request[2]);
    } else {
        setByTriplet(request[0], request[1], request[2]);
        setByTriplet(request[0], request[1], upperCaseOf(request[2]) );
        setByTriplet(request[0], upperCaseOf(request[1]), request[2]);
        setByTriplet(request[0], upperCaseOf(request[1]), upperCaseOf(request[2]) );
        setByTriplet( upperCaseOf(request[0]), request[1], request[2]);
        setByTriplet( upperCaseOf(request[0]), request[1], upperCaseOf(request[2]) );
        setByTriplet( upperCaseOf(request[0]), upperCaseOf(request[1]), request[2]);
        setByTriplet( upperCaseOf(request[0]), upperCaseOf(request[1]), upperCaseOf(request[2]) );
    }

/* Setting a list of repeated items */
    sum = shiftJisKanaAscii();

    switch( sumOfWeight(sum) ) {
    case -1:
        voyaMessage(TOO_LARGE_SUM);
        voyaSumFlush(sum);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    case 0:
        voyaMessageFlush(SUM_EQUALS_ZERO);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    }

    while( repeating() ){}

/* Setting Mersenne Twister (MT) */
    setMT(TIME_USED_AS_SEED, idling);

    if(vc->excludeQuotesGreaterThan) {
/* 
Excluding five symbols: " ' > < & 
*/
        ascii_array = &ascii_subset[0];
        salt_array = &salt_subset[0];
    } else {
        ascii_array = &ascii_set[0];
        salt_array = &salt_set[0];
    }

    salt = & vs->salt[0];
    if( strlen(salt) == 0 ) {
        random_salt(salt, salt_array);
    }

    makeBatchFile();
    while(! terminated) {
        efforts += 1;
        if(efforts == interim_report) {
            if( voyaCtrlTextTouched() ) {
                break;
            }

            efforts = 0;
        }

/* Generating random numbers to produce a key */
        pass[0] = random_ascii(ascii_array);
        pass[1] = '\0';
        s = 1;

        strcat(pass, salt);
        s += SALT_SIZE;

        while(s < CHARACTER_COUNT) { /* s may not equal 8 or 9. */
            d = randomIndex();
            strcat(pass, &character[d][0]);
            s += width[d];
        }

/* Encrypting to produce a tori */
        pass[CHARACTER_COUNT] = '\0';
        q = crypt(pass, salt);
        s = strlen(q) - TEN_FIGURE_TORI;

        if( threePlaces(q[s], q[ s + 1 ], q[ s + 2 ]) ) {
            if(request_length > 3) {
                if(case_sensitive) {
                    b = &q[s]; /* tori */
                    b = strstr(b, request);
                    if(b == NULL) {
                        continue;
                    } else if(b != &q[s]) {
                        continue;
                    }

                } else {
                    k = 0;
                    for(b = &q[s]; *b != '\0'; ++b) {
                        buffer[k++] = tolower(*b);
                    }

                    buffer[k] = '\0';
                    b = &buffer[0];
                    b = strstr(b, request);
                    if(b == NULL) {
                        continue;
                    } else if(b != &buffer[0]) {
                        continue;
                    }

                }

            }

        } else {
            continue;
        }

        strcpy(matched, &q[s]); /* tori */
        count += 1;

/* Expressing the key as hexadecimal */
        buffer[0] = '\0';
        q = &pass[0];
        while(*q != '\0') {
            c = charToInteger(*q);
            strcat(buffer, &h[c][0]); /* hexadecimal */
            ++q;
        }

        strcat(buffer, salt);
        strcat(buffer, FROM_TO);
        strcat(buffer, matched);
        voyaMessageFlush(buffer);

        sprintf(buffer, "%s%d | %s", TOTAL_COLON, count, matched);
        pop_front();
        push_back(buffer);
    }

    free(hugeTable);
    FreeLibrary(cryptGNU);
    closeVoyaError();
    return 0;
}

int seekerAsLeftmostSeek(void) {
    BOOL case_sensitive;
    char *b;
    char *q;
    char buffer[SMALL_BUFFER_SIZE];
    char h[256][3];
    char matched[SMALL_BUFFER_SIZE];
    char pass[ CHARACTER_COUNT + 2 ];
    char request[REQUEST_SIZE];
    CRYPT crypt;
    double sum;
    HMODULE cryptGNU;
    int c, idling, interim_report, k, s;
    int count = 0;
    int efforts = 0;
    int request_length;
    unsigned long d;

/* request */
    if( settingBy(VOYA_CSV) ){
        readLabels();
        request_length = strlen(vs->request);
        if( request_length < 1 ) {
            voyaMessageFlush("request_length < 1");
            closeVoyaError();
            return REQUEST_LENGTH_ERROR;
        } else {
            strcpy(request, vs->request);
        }

    } else {
        voyaMessageFlush("settingBy(VOYA_CSV)");
        closeVoyaError();
        return VOYA_CSV_ERROR;
    }

/* positive numbers */
    idling = vs->idling;
    if(idling < 0) {
        voyaMessageFlush("idling < 0");
        closeVoyaError();
        return IDLING_ERROR;
    }

    interim_report = vs->interim_report;
    if(interim_report < 1) {
        voyaMessageFlush("interim_report < 1");
        closeVoyaError();
        return INTERIM_REPORT_ERROR;
    }

/* GNU crypt.dll */
    cryptGNU = LoadLibrary("crypt.dll");
    crypt = (CRYPT) GetProcAddress(cryptGNU, "crypt");

/* Huge table set by triplet so that threePlaces() can read boolean values */
    hugeTable = (BOOL *)malloc( HALF * HALF * HALF * sizeof(BOOL) );
    if(hugeTable == NULL) {
        voyaMessageFlush("hugeTable == NULL");
        FreeLibrary(cryptGNU);
        closeVoyaError();
        return BOOL_MALLOC_ERROR;
    }

    memset(hugeTable, 0, HALF * HALF * HALF * sizeof(BOOL) );

/* hexadecimal */
    strcpy(&h[  0][0], "00"); strcpy(&h[  1][0], "01"); strcpy(&h[  2][0], "02"); strcpy(&h[  3][0], "03"); strcpy(&h[  4][0], "04"); strcpy(&h[  5][0], "05"); strcpy(&h[  6][0], "06"); strcpy(&h[  7][0], "07"); strcpy(&h[  8][0], "08"); strcpy(&h[  9][0], "09"); strcpy(&h[ 10][0], "0A"); strcpy(&h[ 11][0], "0B");
    strcpy(&h[ 12][0], "0C"); strcpy(&h[ 13][0], "0D"); strcpy(&h[ 14][0], "0E"); strcpy(&h[ 15][0], "0F"); strcpy(&h[ 16][0], "10"); strcpy(&h[ 17][0], "11"); strcpy(&h[ 18][0], "12"); strcpy(&h[ 19][0], "13"); strcpy(&h[ 20][0], "14"); strcpy(&h[ 21][0], "15"); strcpy(&h[ 22][0], "16"); strcpy(&h[ 23][0], "17");
    strcpy(&h[ 24][0], "18"); strcpy(&h[ 25][0], "19"); strcpy(&h[ 26][0], "1A"); strcpy(&h[ 27][0], "1B"); strcpy(&h[ 28][0], "1C"); strcpy(&h[ 29][0], "1D"); strcpy(&h[ 30][0], "1E"); strcpy(&h[ 31][0], "1F"); strcpy(&h[ 32][0], "20"); strcpy(&h[ 33][0], "21"); strcpy(&h[ 34][0], "22"); strcpy(&h[ 35][0], "23");
    strcpy(&h[ 36][0], "24"); strcpy(&h[ 37][0], "25"); strcpy(&h[ 38][0], "26"); strcpy(&h[ 39][0], "27"); strcpy(&h[ 40][0], "28"); strcpy(&h[ 41][0], "29"); strcpy(&h[ 42][0], "2A"); strcpy(&h[ 43][0], "2B"); strcpy(&h[ 44][0], "2C"); strcpy(&h[ 45][0], "2D"); strcpy(&h[ 46][0], "2E"); strcpy(&h[ 47][0], "2F");
    strcpy(&h[ 48][0], "30"); strcpy(&h[ 49][0], "31"); strcpy(&h[ 50][0], "32"); strcpy(&h[ 51][0], "33"); strcpy(&h[ 52][0], "34"); strcpy(&h[ 53][0], "35"); strcpy(&h[ 54][0], "36"); strcpy(&h[ 55][0], "37"); strcpy(&h[ 56][0], "38"); strcpy(&h[ 57][0], "39"); strcpy(&h[ 58][0], "3A"); strcpy(&h[ 59][0], "3B");
    strcpy(&h[ 60][0], "3C"); strcpy(&h[ 61][0], "3D"); strcpy(&h[ 62][0], "3E"); strcpy(&h[ 63][0], "3F"); strcpy(&h[ 64][0], "40"); strcpy(&h[ 65][0], "41"); strcpy(&h[ 66][0], "42"); strcpy(&h[ 67][0], "43"); strcpy(&h[ 68][0], "44"); strcpy(&h[ 69][0], "45"); strcpy(&h[ 70][0], "46"); strcpy(&h[ 71][0], "47");
    strcpy(&h[ 72][0], "48"); strcpy(&h[ 73][0], "49"); strcpy(&h[ 74][0], "4A"); strcpy(&h[ 75][0], "4B"); strcpy(&h[ 76][0], "4C"); strcpy(&h[ 77][0], "4D"); strcpy(&h[ 78][0], "4E"); strcpy(&h[ 79][0], "4F"); strcpy(&h[ 80][0], "50"); strcpy(&h[ 81][0], "51"); strcpy(&h[ 82][0], "52"); strcpy(&h[ 83][0], "53");
    strcpy(&h[ 84][0], "54"); strcpy(&h[ 85][0], "55"); strcpy(&h[ 86][0], "56"); strcpy(&h[ 87][0], "57"); strcpy(&h[ 88][0], "58"); strcpy(&h[ 89][0], "59"); strcpy(&h[ 90][0], "5A"); strcpy(&h[ 91][0], "5B"); strcpy(&h[ 92][0], "5C"); strcpy(&h[ 93][0], "5D"); strcpy(&h[ 94][0], "5E"); strcpy(&h[ 95][0], "5F");
    strcpy(&h[ 96][0], "60"); strcpy(&h[ 97][0], "61"); strcpy(&h[ 98][0], "62"); strcpy(&h[ 99][0], "63"); strcpy(&h[100][0], "64"); strcpy(&h[101][0], "65"); strcpy(&h[102][0], "66"); strcpy(&h[103][0], "67"); strcpy(&h[104][0], "68"); strcpy(&h[105][0], "69"); strcpy(&h[106][0], "6A"); strcpy(&h[107][0], "6B");
    strcpy(&h[108][0], "6C"); strcpy(&h[109][0], "6D"); strcpy(&h[110][0], "6E"); strcpy(&h[111][0], "6F"); strcpy(&h[112][0], "70"); strcpy(&h[113][0], "71"); strcpy(&h[114][0], "72"); strcpy(&h[115][0], "73"); strcpy(&h[116][0], "74"); strcpy(&h[117][0], "75"); strcpy(&h[118][0], "76"); strcpy(&h[119][0], "77");
    strcpy(&h[120][0], "78"); strcpy(&h[121][0], "79"); strcpy(&h[122][0], "7A"); strcpy(&h[123][0], "7B"); strcpy(&h[124][0], "7C"); strcpy(&h[125][0], "7D"); strcpy(&h[126][0], "7E"); strcpy(&h[127][0], "7F"); strcpy(&h[128][0], "80"); strcpy(&h[129][0], "81"); strcpy(&h[130][0], "82"); strcpy(&h[131][0], "83");
    strcpy(&h[132][0], "84"); strcpy(&h[133][0], "85"); strcpy(&h[134][0], "86"); strcpy(&h[135][0], "87"); strcpy(&h[136][0], "88"); strcpy(&h[137][0], "89"); strcpy(&h[138][0], "8A"); strcpy(&h[139][0], "8B"); strcpy(&h[140][0], "8C"); strcpy(&h[141][0], "8D"); strcpy(&h[142][0], "8E"); strcpy(&h[143][0], "8F");
    strcpy(&h[144][0], "90"); strcpy(&h[145][0], "91"); strcpy(&h[146][0], "92"); strcpy(&h[147][0], "93"); strcpy(&h[148][0], "94"); strcpy(&h[149][0], "95"); strcpy(&h[150][0], "96"); strcpy(&h[151][0], "97"); strcpy(&h[152][0], "98"); strcpy(&h[153][0], "99"); strcpy(&h[154][0], "9A"); strcpy(&h[155][0], "9B");
    strcpy(&h[156][0], "9C"); strcpy(&h[157][0], "9D"); strcpy(&h[158][0], "9E"); strcpy(&h[159][0], "9F"); strcpy(&h[160][0], "A0"); strcpy(&h[161][0], "A1"); strcpy(&h[162][0], "A2"); strcpy(&h[163][0], "A3"); strcpy(&h[164][0], "A4"); strcpy(&h[165][0], "A5"); strcpy(&h[166][0], "A6"); strcpy(&h[167][0], "A7");
    strcpy(&h[168][0], "A8"); strcpy(&h[169][0], "A9"); strcpy(&h[170][0], "AA"); strcpy(&h[171][0], "AB"); strcpy(&h[172][0], "AC"); strcpy(&h[173][0], "AD"); strcpy(&h[174][0], "AE"); strcpy(&h[175][0], "AF"); strcpy(&h[176][0], "B0"); strcpy(&h[177][0], "B1"); strcpy(&h[178][0], "B2"); strcpy(&h[179][0], "B3");
    strcpy(&h[180][0], "B4"); strcpy(&h[181][0], "B5"); strcpy(&h[182][0], "B6"); strcpy(&h[183][0], "B7"); strcpy(&h[184][0], "B8"); strcpy(&h[185][0], "B9"); strcpy(&h[186][0], "BA"); strcpy(&h[187][0], "BB"); strcpy(&h[188][0], "BC"); strcpy(&h[189][0], "BD"); strcpy(&h[190][0], "BE"); strcpy(&h[191][0], "BF");
    strcpy(&h[192][0], "C0"); strcpy(&h[193][0], "C1"); strcpy(&h[194][0], "C2"); strcpy(&h[195][0], "C3"); strcpy(&h[196][0], "C4"); strcpy(&h[197][0], "C5"); strcpy(&h[198][0], "C6"); strcpy(&h[199][0], "C7"); strcpy(&h[200][0], "C8"); strcpy(&h[201][0], "C9"); strcpy(&h[202][0], "CA"); strcpy(&h[203][0], "CB");
    strcpy(&h[204][0], "CC"); strcpy(&h[205][0], "CD"); strcpy(&h[206][0], "CE"); strcpy(&h[207][0], "CF"); strcpy(&h[208][0], "D0"); strcpy(&h[209][0], "D1"); strcpy(&h[210][0], "D2"); strcpy(&h[211][0], "D3"); strcpy(&h[212][0], "D4"); strcpy(&h[213][0], "D5"); strcpy(&h[214][0], "D6"); strcpy(&h[215][0], "D7");
    strcpy(&h[216][0], "D8"); strcpy(&h[217][0], "D9"); strcpy(&h[218][0], "DA"); strcpy(&h[219][0], "DB"); strcpy(&h[220][0], "DC"); strcpy(&h[221][0], "DD"); strcpy(&h[222][0], "DE"); strcpy(&h[223][0], "DF"); strcpy(&h[224][0], "E0"); strcpy(&h[225][0], "E1"); strcpy(&h[226][0], "E2"); strcpy(&h[227][0], "E3");
    strcpy(&h[228][0], "E4"); strcpy(&h[229][0], "E5"); strcpy(&h[230][0], "E6"); strcpy(&h[231][0], "E7"); strcpy(&h[232][0], "E8"); strcpy(&h[233][0], "E9"); strcpy(&h[234][0], "EA"); strcpy(&h[235][0], "EB"); strcpy(&h[236][0], "EC"); strcpy(&h[237][0], "ED"); strcpy(&h[238][0], "EE"); strcpy(&h[239][0], "EF");
    strcpy(&h[240][0], "F0"); strcpy(&h[241][0], "F1"); strcpy(&h[242][0], "F2"); strcpy(&h[243][0], "F3"); strcpy(&h[244][0], "F4"); strcpy(&h[245][0], "F5"); strcpy(&h[246][0], "F6"); strcpy(&h[247][0], "F7"); strcpy(&h[248][0], "F8"); strcpy(&h[249][0], "F9"); strcpy(&h[250][0], "FA"); strcpy(&h[251][0], "FB");
    strcpy(&h[252][0], "FC"); strcpy(&h[253][0], "FD"); strcpy(&h[254][0], "FE"); strcpy(&h[255][0], "FF");

/* request */
    request_length = strlen(request);
    if(request_length < 3) {
        strcat(request, COMPLEMENT);
        request[3] = '\0';
    }

    case_sensitive = vs->case_sensitive;
    if(case_sensitive) {
        setByTriplet(request[0], request[1], request[2]);
    } else {
        setByTriplet(request[0], request[1], request[2]);
        setByTriplet(request[0], request[1], upperCaseOf(request[2]) );
        setByTriplet(request[0], upperCaseOf(request[1]), request[2]);
        setByTriplet(request[0], upperCaseOf(request[1]), upperCaseOf(request[2]) );
        setByTriplet( upperCaseOf(request[0]), request[1], request[2]);
        setByTriplet( upperCaseOf(request[0]), request[1], upperCaseOf(request[2]) );
        setByTriplet( upperCaseOf(request[0]), upperCaseOf(request[1]), request[2]);
        setByTriplet( upperCaseOf(request[0]), upperCaseOf(request[1]), upperCaseOf(request[2]) );
    }

/* Setting a list of repeated items */
    sum = shiftJisKanaAscii();

    switch( sumOfWeight(sum) ) {
    case -1:
        voyaMessage(TOO_LARGE_SUM);
        voyaSumFlush(sum);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    case 0:
        voyaMessageFlush(SUM_EQUALS_ZERO);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    }

    while( repeating() ){}

/* Setting Mersenne Twister (MT) */
    setMT(TIME_USED_AS_SEED, idling);

    makeBatchFile();
    while(! terminated) {
        efforts += 1;
        if(efforts == interim_report) {
            if( voyaCtrlTextTouched() ) {
                break;
            }

            efforts = 0;
        }

/* Generating random numbers to produce a key */
        pass[0] = '\0';
        s = 0;
        while(s < CHARACTER_COUNT) { /* s may not equal 8 or 9. */
            d = randomIndex();
            strcat(pass, &character[d][0]);
            s += width[d];
        }

/* Encrypting to produce a tori */
        pass[CHARACTER_COUNT] = '\0';
        q = crypt(pass, "..");
        s = strlen(q) - TEN_FIGURE_TORI;

        if( threePlaces(q[s], q[ s + 1 ], q[ s + 2 ]) ) {
            if(request_length > 3) {
                if(case_sensitive) {
                    b = &q[s]; /* tori */
                    b = strstr(b, request);
                    if(b == NULL) {
                        continue;
                    } else if(b != &q[s]) {
                        continue;
                    }

                } else {
                    k = 0;
                    for(b = &q[s]; *b != '\0'; ++b) {
                        buffer[k++] = tolower(*b);
                    }

                    buffer[k] = '\0';
                    b = &buffer[0];
                    b = strstr(b, request);
                    if(b == NULL) {
                        continue;
                    } else if(b != &buffer[0]) {
                        continue;
                    }

                }

            }

        } else {
            continue;
        }

        strcpy(matched, &q[s]); /* tori */
        count += 1;

/* Expressing the key as hexadecimal */
        buffer[0] = '\0';
        q = &pass[0];
        while(*q != '\0') {
            c = charToInteger(*q);
            strcat(buffer, &h[c][0]); /* hexadecimal */
            ++q;
        }

        strcat(buffer, FROM_TO);
        strcat(buffer, matched);
        voyaMessageFlush(buffer);

        sprintf(buffer, "%s%d | %s", TOTAL_COLON, count, matched);
        pop_front();
        push_back(buffer);
    }

    free(hugeTable);
    FreeLibrary(cryptGNU);
    closeVoyaError();
    return 0;
}

int seekerAsRegularExpression(void) {
    char *q;
    char buffer[SMALL_BUFFER_SIZE];
    char h[256][3];
    char matched[SMALL_BUFFER_SIZE];
    char pass[ CHARACTER_COUNT + 2 ];
    char request[REQUEST_SIZE];
    CRYPT crypt;
    double sum;
    HMODULE cryptGNU, spencerREGEX;
    int c, error_code, idling, interim_report, s;
    int count = 0;
    int efforts = 0;
    int request_length;
    regmatch_t pmatch[1];
    REGCOMP regcomp;
    REGEXEC regexec;
    regex_t reg;
    regex_t *preg = &reg;
    REGFREE regfree;
    unsigned long d;

/* request */
    if( settingBy(VOYA_CSV) ){
        readLabels();
        request_length = strlen(vs->request);
        if( request_length < 1 ) {
            voyaMessageFlush("request_length < 1");
            closeVoyaError();
            return REQUEST_LENGTH_ERROR;
        } else {
            strcpy(request, vs->request);
        }

    } else {
        voyaMessageFlush("settingBy(VOYA_CSV)");
        closeVoyaError();
        return VOYA_CSV_ERROR;
    }

/* positive numbers */
    idling = vs->idling;
    if(idling < 0) {
        voyaMessageFlush("idling < 0");
        closeVoyaError();
        return IDLING_ERROR;
    }

    interim_report = vs->interim_report;
    if(interim_report < 1) {
        voyaMessageFlush("interim_report < 1");
        closeVoyaError();
        return INTERIM_REPORT_ERROR;
    }

/* REGEX rxspencer.dll */
    spencerREGEX = LoadLibrary("rxspencer.dll");
    if(spencerREGEX == NULL) {
        voyaMessageFlush("LoadLibrary(\"rxspencer.dll\")");
        closeVoyaError();
        return REGEX_ERROR;
    }

    regcomp = (REGCOMP) GetProcAddress(spencerREGEX, "regcomp");
    regexec = (REGEXEC) GetProcAddress(spencerREGEX, "regexec");
    regfree = (REGFREE) GetProcAddress(spencerREGEX, "regfree");

    error_code = regcomp(preg, request, REG_EXTENDED | REG_NOSUB);
    switch(error_code) {
    case REG_BADPAT:
        voyaMessageFlush("invalid regular expression");
        closeVoyaError();
        FreeLibrary(spencerREGEX);
        return REGEX_ERROR;
    case REG_ECOLLATE:
        voyaMessageFlush("invalid collating element");
        closeVoyaError();
        FreeLibrary(spencerREGEX);
        return REGEX_ERROR;
    case REG_ECTYPE:
        voyaMessageFlush("invalid character class");
        closeVoyaError();
        FreeLibrary(spencerREGEX);
        return REGEX_ERROR;
    case REG_EESCAPE:
        voyaMessageFlush("\\ applied to unescapable character");
        closeVoyaError();
        FreeLibrary(spencerREGEX);
        return REGEX_ERROR;
    case REG_ESUBREG:
        voyaMessageFlush("invalid backreference number");
        closeVoyaError();
        FreeLibrary(spencerREGEX);
        return REGEX_ERROR;
    case REG_EBRACK:
        voyaMessageFlush("brackets [ ] not balanced");
        closeVoyaError();
        FreeLibrary(spencerREGEX);
        return REGEX_ERROR;
    case REG_EPAREN:
        voyaMessageFlush("parentheses ( ) not balanced");
        closeVoyaError();
        FreeLibrary(spencerREGEX);
        return REGEX_ERROR;
    case REG_EBRACE:
        voyaMessageFlush("braces { } not balanced");
        closeVoyaError();
        FreeLibrary(spencerREGEX);
        return REGEX_ERROR;
    case REG_BADBR:
        voyaMessageFlush("invalid repetition count(s) in { }");
        closeVoyaError();
        FreeLibrary(spencerREGEX);
        return REGEX_ERROR;
    case REG_ERANGE:
        voyaMessageFlush("invalid character range in [ ]");
        closeVoyaError();
        FreeLibrary(spencerREGEX);
        return REGEX_ERROR;
    case REG_ESPACE:
        voyaMessageFlush("ran out of memory");
        closeVoyaError();
        FreeLibrary(spencerREGEX);
        return REGEX_ERROR;
    case REG_BADRPT:
        voyaMessageFlush("?, *, or + operand invalid");
        closeVoyaError();
        FreeLibrary(spencerREGEX);
        return REGEX_ERROR;
    case REG_EMPTY:
        voyaMessageFlush("empty (sub)expression");
        closeVoyaError();
        FreeLibrary(spencerREGEX);
        return REGEX_ERROR;
    case REG_ASSERT:
        voyaMessageFlush("``can't happen''--you found a bug");
        closeVoyaError();
        FreeLibrary(spencerREGEX);
        return REGEX_ERROR;
    case REG_INVARG:
        voyaMessageFlush("invalid argument, e.g. negative-length string");
        closeVoyaError();
        FreeLibrary(spencerREGEX);
        return REGEX_ERROR;
    }

/* GNU crypt.dll */
    cryptGNU = LoadLibrary("crypt.dll");
    crypt = (CRYPT) GetProcAddress(cryptGNU, "crypt");

/* hexadecimal */
    strcpy(&h[  0][0], "00"); strcpy(&h[  1][0], "01"); strcpy(&h[  2][0], "02"); strcpy(&h[  3][0], "03"); strcpy(&h[  4][0], "04"); strcpy(&h[  5][0], "05"); strcpy(&h[  6][0], "06"); strcpy(&h[  7][0], "07"); strcpy(&h[  8][0], "08"); strcpy(&h[  9][0], "09"); strcpy(&h[ 10][0], "0A"); strcpy(&h[ 11][0], "0B");
    strcpy(&h[ 12][0], "0C"); strcpy(&h[ 13][0], "0D"); strcpy(&h[ 14][0], "0E"); strcpy(&h[ 15][0], "0F"); strcpy(&h[ 16][0], "10"); strcpy(&h[ 17][0], "11"); strcpy(&h[ 18][0], "12"); strcpy(&h[ 19][0], "13"); strcpy(&h[ 20][0], "14"); strcpy(&h[ 21][0], "15"); strcpy(&h[ 22][0], "16"); strcpy(&h[ 23][0], "17");
    strcpy(&h[ 24][0], "18"); strcpy(&h[ 25][0], "19"); strcpy(&h[ 26][0], "1A"); strcpy(&h[ 27][0], "1B"); strcpy(&h[ 28][0], "1C"); strcpy(&h[ 29][0], "1D"); strcpy(&h[ 30][0], "1E"); strcpy(&h[ 31][0], "1F"); strcpy(&h[ 32][0], "20"); strcpy(&h[ 33][0], "21"); strcpy(&h[ 34][0], "22"); strcpy(&h[ 35][0], "23");
    strcpy(&h[ 36][0], "24"); strcpy(&h[ 37][0], "25"); strcpy(&h[ 38][0], "26"); strcpy(&h[ 39][0], "27"); strcpy(&h[ 40][0], "28"); strcpy(&h[ 41][0], "29"); strcpy(&h[ 42][0], "2A"); strcpy(&h[ 43][0], "2B"); strcpy(&h[ 44][0], "2C"); strcpy(&h[ 45][0], "2D"); strcpy(&h[ 46][0], "2E"); strcpy(&h[ 47][0], "2F");
    strcpy(&h[ 48][0], "30"); strcpy(&h[ 49][0], "31"); strcpy(&h[ 50][0], "32"); strcpy(&h[ 51][0], "33"); strcpy(&h[ 52][0], "34"); strcpy(&h[ 53][0], "35"); strcpy(&h[ 54][0], "36"); strcpy(&h[ 55][0], "37"); strcpy(&h[ 56][0], "38"); strcpy(&h[ 57][0], "39"); strcpy(&h[ 58][0], "3A"); strcpy(&h[ 59][0], "3B");
    strcpy(&h[ 60][0], "3C"); strcpy(&h[ 61][0], "3D"); strcpy(&h[ 62][0], "3E"); strcpy(&h[ 63][0], "3F"); strcpy(&h[ 64][0], "40"); strcpy(&h[ 65][0], "41"); strcpy(&h[ 66][0], "42"); strcpy(&h[ 67][0], "43"); strcpy(&h[ 68][0], "44"); strcpy(&h[ 69][0], "45"); strcpy(&h[ 70][0], "46"); strcpy(&h[ 71][0], "47");
    strcpy(&h[ 72][0], "48"); strcpy(&h[ 73][0], "49"); strcpy(&h[ 74][0], "4A"); strcpy(&h[ 75][0], "4B"); strcpy(&h[ 76][0], "4C"); strcpy(&h[ 77][0], "4D"); strcpy(&h[ 78][0], "4E"); strcpy(&h[ 79][0], "4F"); strcpy(&h[ 80][0], "50"); strcpy(&h[ 81][0], "51"); strcpy(&h[ 82][0], "52"); strcpy(&h[ 83][0], "53");
    strcpy(&h[ 84][0], "54"); strcpy(&h[ 85][0], "55"); strcpy(&h[ 86][0], "56"); strcpy(&h[ 87][0], "57"); strcpy(&h[ 88][0], "58"); strcpy(&h[ 89][0], "59"); strcpy(&h[ 90][0], "5A"); strcpy(&h[ 91][0], "5B"); strcpy(&h[ 92][0], "5C"); strcpy(&h[ 93][0], "5D"); strcpy(&h[ 94][0], "5E"); strcpy(&h[ 95][0], "5F");
    strcpy(&h[ 96][0], "60"); strcpy(&h[ 97][0], "61"); strcpy(&h[ 98][0], "62"); strcpy(&h[ 99][0], "63"); strcpy(&h[100][0], "64"); strcpy(&h[101][0], "65"); strcpy(&h[102][0], "66"); strcpy(&h[103][0], "67"); strcpy(&h[104][0], "68"); strcpy(&h[105][0], "69"); strcpy(&h[106][0], "6A"); strcpy(&h[107][0], "6B");
    strcpy(&h[108][0], "6C"); strcpy(&h[109][0], "6D"); strcpy(&h[110][0], "6E"); strcpy(&h[111][0], "6F"); strcpy(&h[112][0], "70"); strcpy(&h[113][0], "71"); strcpy(&h[114][0], "72"); strcpy(&h[115][0], "73"); strcpy(&h[116][0], "74"); strcpy(&h[117][0], "75"); strcpy(&h[118][0], "76"); strcpy(&h[119][0], "77");
    strcpy(&h[120][0], "78"); strcpy(&h[121][0], "79"); strcpy(&h[122][0], "7A"); strcpy(&h[123][0], "7B"); strcpy(&h[124][0], "7C"); strcpy(&h[125][0], "7D"); strcpy(&h[126][0], "7E"); strcpy(&h[127][0], "7F"); strcpy(&h[128][0], "80"); strcpy(&h[129][0], "81"); strcpy(&h[130][0], "82"); strcpy(&h[131][0], "83");
    strcpy(&h[132][0], "84"); strcpy(&h[133][0], "85"); strcpy(&h[134][0], "86"); strcpy(&h[135][0], "87"); strcpy(&h[136][0], "88"); strcpy(&h[137][0], "89"); strcpy(&h[138][0], "8A"); strcpy(&h[139][0], "8B"); strcpy(&h[140][0], "8C"); strcpy(&h[141][0], "8D"); strcpy(&h[142][0], "8E"); strcpy(&h[143][0], "8F");
    strcpy(&h[144][0], "90"); strcpy(&h[145][0], "91"); strcpy(&h[146][0], "92"); strcpy(&h[147][0], "93"); strcpy(&h[148][0], "94"); strcpy(&h[149][0], "95"); strcpy(&h[150][0], "96"); strcpy(&h[151][0], "97"); strcpy(&h[152][0], "98"); strcpy(&h[153][0], "99"); strcpy(&h[154][0], "9A"); strcpy(&h[155][0], "9B");
    strcpy(&h[156][0], "9C"); strcpy(&h[157][0], "9D"); strcpy(&h[158][0], "9E"); strcpy(&h[159][0], "9F"); strcpy(&h[160][0], "A0"); strcpy(&h[161][0], "A1"); strcpy(&h[162][0], "A2"); strcpy(&h[163][0], "A3"); strcpy(&h[164][0], "A4"); strcpy(&h[165][0], "A5"); strcpy(&h[166][0], "A6"); strcpy(&h[167][0], "A7");
    strcpy(&h[168][0], "A8"); strcpy(&h[169][0], "A9"); strcpy(&h[170][0], "AA"); strcpy(&h[171][0], "AB"); strcpy(&h[172][0], "AC"); strcpy(&h[173][0], "AD"); strcpy(&h[174][0], "AE"); strcpy(&h[175][0], "AF"); strcpy(&h[176][0], "B0"); strcpy(&h[177][0], "B1"); strcpy(&h[178][0], "B2"); strcpy(&h[179][0], "B3");
    strcpy(&h[180][0], "B4"); strcpy(&h[181][0], "B5"); strcpy(&h[182][0], "B6"); strcpy(&h[183][0], "B7"); strcpy(&h[184][0], "B8"); strcpy(&h[185][0], "B9"); strcpy(&h[186][0], "BA"); strcpy(&h[187][0], "BB"); strcpy(&h[188][0], "BC"); strcpy(&h[189][0], "BD"); strcpy(&h[190][0], "BE"); strcpy(&h[191][0], "BF");
    strcpy(&h[192][0], "C0"); strcpy(&h[193][0], "C1"); strcpy(&h[194][0], "C2"); strcpy(&h[195][0], "C3"); strcpy(&h[196][0], "C4"); strcpy(&h[197][0], "C5"); strcpy(&h[198][0], "C6"); strcpy(&h[199][0], "C7"); strcpy(&h[200][0], "C8"); strcpy(&h[201][0], "C9"); strcpy(&h[202][0], "CA"); strcpy(&h[203][0], "CB");
    strcpy(&h[204][0], "CC"); strcpy(&h[205][0], "CD"); strcpy(&h[206][0], "CE"); strcpy(&h[207][0], "CF"); strcpy(&h[208][0], "D0"); strcpy(&h[209][0], "D1"); strcpy(&h[210][0], "D2"); strcpy(&h[211][0], "D3"); strcpy(&h[212][0], "D4"); strcpy(&h[213][0], "D5"); strcpy(&h[214][0], "D6"); strcpy(&h[215][0], "D7");
    strcpy(&h[216][0], "D8"); strcpy(&h[217][0], "D9"); strcpy(&h[218][0], "DA"); strcpy(&h[219][0], "DB"); strcpy(&h[220][0], "DC"); strcpy(&h[221][0], "DD"); strcpy(&h[222][0], "DE"); strcpy(&h[223][0], "DF"); strcpy(&h[224][0], "E0"); strcpy(&h[225][0], "E1"); strcpy(&h[226][0], "E2"); strcpy(&h[227][0], "E3");
    strcpy(&h[228][0], "E4"); strcpy(&h[229][0], "E5"); strcpy(&h[230][0], "E6"); strcpy(&h[231][0], "E7"); strcpy(&h[232][0], "E8"); strcpy(&h[233][0], "E9"); strcpy(&h[234][0], "EA"); strcpy(&h[235][0], "EB"); strcpy(&h[236][0], "EC"); strcpy(&h[237][0], "ED"); strcpy(&h[238][0], "EE"); strcpy(&h[239][0], "EF");
    strcpy(&h[240][0], "F0"); strcpy(&h[241][0], "F1"); strcpy(&h[242][0], "F2"); strcpy(&h[243][0], "F3"); strcpy(&h[244][0], "F4"); strcpy(&h[245][0], "F5"); strcpy(&h[246][0], "F6"); strcpy(&h[247][0], "F7"); strcpy(&h[248][0], "F8"); strcpy(&h[249][0], "F9"); strcpy(&h[250][0], "FA"); strcpy(&h[251][0], "FB");
    strcpy(&h[252][0], "FC"); strcpy(&h[253][0], "FD"); strcpy(&h[254][0], "FE"); strcpy(&h[255][0], "FF");

/* Setting a list of repeated items */
    sum = shiftJisKanaAscii();

    switch( sumOfWeight(sum) ) {
    case -1:
        voyaMessage(TOO_LARGE_SUM);
        voyaSumFlush(sum);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    case 0:
        voyaMessageFlush(SUM_EQUALS_ZERO);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    }

    while( repeating() ){}

/* Setting Mersenne Twister (MT) */
    setMT(TIME_USED_AS_SEED, idling);

    makeBatchFile();
    while(! terminated) {
        efforts += 1;
        if(efforts == interim_report) {
            if( voyaCtrlTextTouched() ) {
                break;
            }

            efforts = 0;
        }

/* Generating random numbers to produce a key */
        pass[0] = '\0';
        s = 0;
        while(s < CHARACTER_COUNT) { /* s may not equal 8 or 9. */
            d = randomIndex();
            strcat(pass, &character[d][0]);
            s += width[d];
        }

/* Encrypting to produce a tori */
        pass[CHARACTER_COUNT] = '\0';
        q = crypt(pass, "..");
        s = strlen(q) - TEN_FIGURE_TORI;

        error_code = regexec(preg, &q[s], 0, pmatch, 0);
        if(error_code) {
            continue;
        }

        strcpy(matched, &q[s]); /* tori */
        count += 1;

/* Expressing the key as hexadecimal */
        buffer[0] = '\0';
        q = &pass[0];
        while(*q != '\0') {
            c = charToInteger(*q);
            strcat(buffer, &h[c][0]); /* hexadecimal */
            ++q;
        }

        strcat(buffer, FROM_TO);
        strcat(buffer, matched);
        voyaMessageFlush(buffer);

        sprintf(buffer, "%s%d | %s", TOTAL_COLON, count, matched);
        pop_front();
        push_back(buffer);
    }

    regfree(preg);
    FreeLibrary(spencerREGEX);
    FreeLibrary(cryptGNU);
    closeVoyaError();
    return 0;
}

int seekerAsRightmostSeek(void) {
    BOOL case_sensitive;
    char *b;
    char *p;
    char *q;
    char buffer[SMALL_BUFFER_SIZE];
    char h[256][3];
    char matched[SMALL_BUFFER_SIZE];
    char pass[ CHARACTER_COUNT + 2 ];
    char request[REQUEST_SIZE];
    char toriTail[REQUEST_SIZE];
    char tseu[REQUEST_SIZE];
    const int TSEU_LENGTH = 3;
    CRYPT crypt;
    double sum;
    HMODULE cryptGNU;
    int c, idling, interim_report, k, s, u;
    int count = 0;
    int efforts = 0;
    int request_length;
    int reverseLength;
    unsigned long d;

/* request */
    if( settingBy(VOYA_CSV) ){
        readLabels();
        request_length = strlen(vs->request);
        if( request_length < 1 ) {
            voyaMessageFlush("request_length < 1");
            closeVoyaError();
            return 1;
        } else {
            strcpy(request, vs->request);
        }

    } else {
        voyaMessageFlush("settingBy(VOYA_CSV)");
        closeVoyaError();
        return VOYA_CSV_ERROR;
    }

/* positive numbers */
    idling = vs->idling;
    if(idling < 0) {
        voyaMessageFlush("idling < 0");
        closeVoyaError();
        return IDLING_ERROR;
    }

    interim_report = vs->interim_report;
    if(interim_report < 1) {
        voyaMessageFlush("interim_report < 1");
        closeVoyaError();
        return INTERIM_REPORT_ERROR;
    }

/* GNU crypt.dll */
    cryptGNU = LoadLibrary("crypt.dll");
    crypt = (CRYPT) GetProcAddress(cryptGNU, "crypt");

/* Huge table set by triplet so that threePlaces() can read boolean values */
    hugeTable = (BOOL *)malloc( HALF * HALF * HALF * sizeof(BOOL) );
    if(hugeTable == NULL) {
        voyaMessageFlush("hugeTable == NULL");
        FreeLibrary(cryptGNU);
        closeVoyaError();
        return BOOL_MALLOC_ERROR;
    }

    memset(hugeTable, 0, HALF * HALF * HALF * sizeof(BOOL) );

/* hexadecimal */
    strcpy(&h[  0][0], "00"); strcpy(&h[  1][0], "01"); strcpy(&h[  2][0], "02"); strcpy(&h[  3][0], "03"); strcpy(&h[  4][0], "04"); strcpy(&h[  5][0], "05"); strcpy(&h[  6][0], "06"); strcpy(&h[  7][0], "07"); strcpy(&h[  8][0], "08"); strcpy(&h[  9][0], "09"); strcpy(&h[ 10][0], "0A"); strcpy(&h[ 11][0], "0B");
    strcpy(&h[ 12][0], "0C"); strcpy(&h[ 13][0], "0D"); strcpy(&h[ 14][0], "0E"); strcpy(&h[ 15][0], "0F"); strcpy(&h[ 16][0], "10"); strcpy(&h[ 17][0], "11"); strcpy(&h[ 18][0], "12"); strcpy(&h[ 19][0], "13"); strcpy(&h[ 20][0], "14"); strcpy(&h[ 21][0], "15"); strcpy(&h[ 22][0], "16"); strcpy(&h[ 23][0], "17");
    strcpy(&h[ 24][0], "18"); strcpy(&h[ 25][0], "19"); strcpy(&h[ 26][0], "1A"); strcpy(&h[ 27][0], "1B"); strcpy(&h[ 28][0], "1C"); strcpy(&h[ 29][0], "1D"); strcpy(&h[ 30][0], "1E"); strcpy(&h[ 31][0], "1F"); strcpy(&h[ 32][0], "20"); strcpy(&h[ 33][0], "21"); strcpy(&h[ 34][0], "22"); strcpy(&h[ 35][0], "23");
    strcpy(&h[ 36][0], "24"); strcpy(&h[ 37][0], "25"); strcpy(&h[ 38][0], "26"); strcpy(&h[ 39][0], "27"); strcpy(&h[ 40][0], "28"); strcpy(&h[ 41][0], "29"); strcpy(&h[ 42][0], "2A"); strcpy(&h[ 43][0], "2B"); strcpy(&h[ 44][0], "2C"); strcpy(&h[ 45][0], "2D"); strcpy(&h[ 46][0], "2E"); strcpy(&h[ 47][0], "2F");
    strcpy(&h[ 48][0], "30"); strcpy(&h[ 49][0], "31"); strcpy(&h[ 50][0], "32"); strcpy(&h[ 51][0], "33"); strcpy(&h[ 52][0], "34"); strcpy(&h[ 53][0], "35"); strcpy(&h[ 54][0], "36"); strcpy(&h[ 55][0], "37"); strcpy(&h[ 56][0], "38"); strcpy(&h[ 57][0], "39"); strcpy(&h[ 58][0], "3A"); strcpy(&h[ 59][0], "3B");
    strcpy(&h[ 60][0], "3C"); strcpy(&h[ 61][0], "3D"); strcpy(&h[ 62][0], "3E"); strcpy(&h[ 63][0], "3F"); strcpy(&h[ 64][0], "40"); strcpy(&h[ 65][0], "41"); strcpy(&h[ 66][0], "42"); strcpy(&h[ 67][0], "43"); strcpy(&h[ 68][0], "44"); strcpy(&h[ 69][0], "45"); strcpy(&h[ 70][0], "46"); strcpy(&h[ 71][0], "47");
    strcpy(&h[ 72][0], "48"); strcpy(&h[ 73][0], "49"); strcpy(&h[ 74][0], "4A"); strcpy(&h[ 75][0], "4B"); strcpy(&h[ 76][0], "4C"); strcpy(&h[ 77][0], "4D"); strcpy(&h[ 78][0], "4E"); strcpy(&h[ 79][0], "4F"); strcpy(&h[ 80][0], "50"); strcpy(&h[ 81][0], "51"); strcpy(&h[ 82][0], "52"); strcpy(&h[ 83][0], "53");
    strcpy(&h[ 84][0], "54"); strcpy(&h[ 85][0], "55"); strcpy(&h[ 86][0], "56"); strcpy(&h[ 87][0], "57"); strcpy(&h[ 88][0], "58"); strcpy(&h[ 89][0], "59"); strcpy(&h[ 90][0], "5A"); strcpy(&h[ 91][0], "5B"); strcpy(&h[ 92][0], "5C"); strcpy(&h[ 93][0], "5D"); strcpy(&h[ 94][0], "5E"); strcpy(&h[ 95][0], "5F");
    strcpy(&h[ 96][0], "60"); strcpy(&h[ 97][0], "61"); strcpy(&h[ 98][0], "62"); strcpy(&h[ 99][0], "63"); strcpy(&h[100][0], "64"); strcpy(&h[101][0], "65"); strcpy(&h[102][0], "66"); strcpy(&h[103][0], "67"); strcpy(&h[104][0], "68"); strcpy(&h[105][0], "69"); strcpy(&h[106][0], "6A"); strcpy(&h[107][0], "6B");
    strcpy(&h[108][0], "6C"); strcpy(&h[109][0], "6D"); strcpy(&h[110][0], "6E"); strcpy(&h[111][0], "6F"); strcpy(&h[112][0], "70"); strcpy(&h[113][0], "71"); strcpy(&h[114][0], "72"); strcpy(&h[115][0], "73"); strcpy(&h[116][0], "74"); strcpy(&h[117][0], "75"); strcpy(&h[118][0], "76"); strcpy(&h[119][0], "77");
    strcpy(&h[120][0], "78"); strcpy(&h[121][0], "79"); strcpy(&h[122][0], "7A"); strcpy(&h[123][0], "7B"); strcpy(&h[124][0], "7C"); strcpy(&h[125][0], "7D"); strcpy(&h[126][0], "7E"); strcpy(&h[127][0], "7F"); strcpy(&h[128][0], "80"); strcpy(&h[129][0], "81"); strcpy(&h[130][0], "82"); strcpy(&h[131][0], "83");
    strcpy(&h[132][0], "84"); strcpy(&h[133][0], "85"); strcpy(&h[134][0], "86"); strcpy(&h[135][0], "87"); strcpy(&h[136][0], "88"); strcpy(&h[137][0], "89"); strcpy(&h[138][0], "8A"); strcpy(&h[139][0], "8B"); strcpy(&h[140][0], "8C"); strcpy(&h[141][0], "8D"); strcpy(&h[142][0], "8E"); strcpy(&h[143][0], "8F");
    strcpy(&h[144][0], "90"); strcpy(&h[145][0], "91"); strcpy(&h[146][0], "92"); strcpy(&h[147][0], "93"); strcpy(&h[148][0], "94"); strcpy(&h[149][0], "95"); strcpy(&h[150][0], "96"); strcpy(&h[151][0], "97"); strcpy(&h[152][0], "98"); strcpy(&h[153][0], "99"); strcpy(&h[154][0], "9A"); strcpy(&h[155][0], "9B");
    strcpy(&h[156][0], "9C"); strcpy(&h[157][0], "9D"); strcpy(&h[158][0], "9E"); strcpy(&h[159][0], "9F"); strcpy(&h[160][0], "A0"); strcpy(&h[161][0], "A1"); strcpy(&h[162][0], "A2"); strcpy(&h[163][0], "A3"); strcpy(&h[164][0], "A4"); strcpy(&h[165][0], "A5"); strcpy(&h[166][0], "A6"); strcpy(&h[167][0], "A7");
    strcpy(&h[168][0], "A8"); strcpy(&h[169][0], "A9"); strcpy(&h[170][0], "AA"); strcpy(&h[171][0], "AB"); strcpy(&h[172][0], "AC"); strcpy(&h[173][0], "AD"); strcpy(&h[174][0], "AE"); strcpy(&h[175][0], "AF"); strcpy(&h[176][0], "B0"); strcpy(&h[177][0], "B1"); strcpy(&h[178][0], "B2"); strcpy(&h[179][0], "B3");
    strcpy(&h[180][0], "B4"); strcpy(&h[181][0], "B5"); strcpy(&h[182][0], "B6"); strcpy(&h[183][0], "B7"); strcpy(&h[184][0], "B8"); strcpy(&h[185][0], "B9"); strcpy(&h[186][0], "BA"); strcpy(&h[187][0], "BB"); strcpy(&h[188][0], "BC"); strcpy(&h[189][0], "BD"); strcpy(&h[190][0], "BE"); strcpy(&h[191][0], "BF");
    strcpy(&h[192][0], "C0"); strcpy(&h[193][0], "C1"); strcpy(&h[194][0], "C2"); strcpy(&h[195][0], "C3"); strcpy(&h[196][0], "C4"); strcpy(&h[197][0], "C5"); strcpy(&h[198][0], "C6"); strcpy(&h[199][0], "C7"); strcpy(&h[200][0], "C8"); strcpy(&h[201][0], "C9"); strcpy(&h[202][0], "CA"); strcpy(&h[203][0], "CB");
    strcpy(&h[204][0], "CC"); strcpy(&h[205][0], "CD"); strcpy(&h[206][0], "CE"); strcpy(&h[207][0], "CF"); strcpy(&h[208][0], "D0"); strcpy(&h[209][0], "D1"); strcpy(&h[210][0], "D2"); strcpy(&h[211][0], "D3"); strcpy(&h[212][0], "D4"); strcpy(&h[213][0], "D5"); strcpy(&h[214][0], "D6"); strcpy(&h[215][0], "D7");
    strcpy(&h[216][0], "D8"); strcpy(&h[217][0], "D9"); strcpy(&h[218][0], "DA"); strcpy(&h[219][0], "DB"); strcpy(&h[220][0], "DC"); strcpy(&h[221][0], "DD"); strcpy(&h[222][0], "DE"); strcpy(&h[223][0], "DF"); strcpy(&h[224][0], "E0"); strcpy(&h[225][0], "E1"); strcpy(&h[226][0], "E2"); strcpy(&h[227][0], "E3");
    strcpy(&h[228][0], "E4"); strcpy(&h[229][0], "E5"); strcpy(&h[230][0], "E6"); strcpy(&h[231][0], "E7"); strcpy(&h[232][0], "E8"); strcpy(&h[233][0], "E9"); strcpy(&h[234][0], "EA"); strcpy(&h[235][0], "EB"); strcpy(&h[236][0], "EC"); strcpy(&h[237][0], "ED"); strcpy(&h[238][0], "EE"); strcpy(&h[239][0], "EF");
    strcpy(&h[240][0], "F0"); strcpy(&h[241][0], "F1"); strcpy(&h[242][0], "F2"); strcpy(&h[243][0], "F3"); strcpy(&h[244][0], "F4"); strcpy(&h[245][0], "F5"); strcpy(&h[246][0], "F6"); strcpy(&h[247][0], "F7"); strcpy(&h[248][0], "F8"); strcpy(&h[249][0], "F9"); strcpy(&h[250][0], "FA"); strcpy(&h[251][0], "FB");
    strcpy(&h[252][0], "FC"); strcpy(&h[253][0], "FD"); strcpy(&h[254][0], "FE"); strcpy(&h[255][0], "FF");

/* request */
    request_length = strlen(request);
    if(request_length < 3) {
        strcpy(reverseComplement, REVERSE_COMPLEMENT);
        strcat(reverseComplement, request);
        reverseLength = strlen(reverseComplement);
        request[3] = '\0';
        request[2] = reverseComplement[ reverseLength - 1 ];
        request[1] = reverseComplement[ reverseLength - 2 ];
        request[0] = reverseComplement[ reverseLength - 3 ];
        request_length = 3;
    }

    strcpy(tseu, request);
    strrev(tseu);

    case_sensitive = vs->case_sensitive;
    if(case_sensitive) {
        setByTriplet(tseu[2], tseu[1], tseu[0]);
    } else {
        setByTriplet(tseu[2], tseu[1], tseu[0]);
        setByTriplet(tseu[2], tseu[1], upperCaseOf(tseu[0]) );
        setByTriplet(tseu[2], upperCaseOf(tseu[1]), tseu[0]);
        setByTriplet(tseu[2], upperCaseOf(tseu[1]), upperCaseOf(tseu[0]) );
        setByTriplet( upperCaseOf(tseu[2]), tseu[1], tseu[0]);
        setByTriplet( upperCaseOf(tseu[2]), tseu[1], upperCaseOf(tseu[0]) );
        setByTriplet( upperCaseOf(tseu[2]), upperCaseOf(tseu[1]), tseu[0]);
        setByTriplet( upperCaseOf(tseu[2]), upperCaseOf(tseu[1]), upperCaseOf(tseu[0]) );
    }

/* Setting a list of repeated items */
    sum = shiftJisKanaAscii();

    switch( sumOfWeight(sum) ) {
    case -1:
        voyaMessage(TOO_LARGE_SUM);
        voyaSumFlush(sum);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    case 0:
        voyaMessageFlush(SUM_EQUALS_ZERO);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    }

    while( repeating() ){}

/* Setting Mersenne Twister (MT) */
    setMT(TIME_USED_AS_SEED, idling);

    makeBatchFile();
    while(! terminated) {
        efforts += 1;
        if(efforts == interim_report) {
            if( voyaCtrlTextTouched() ) {
                break;
            }

            efforts = 0;
        }

/* Generating random numbers to produce a key */
        pass[0] = '\0';
        s = 0;
        while(s < CHARACTER_COUNT) { /* s may not equal 8 or 9. */
            d = randomIndex();
            strcat(pass, &character[d][0]);
            s += width[d];
        }

/* Encrypting to produce a tori */
        pass[CHARACTER_COUNT] = '\0';
        q = crypt(pass, "..");
        s = strlen(q) - TEN_FIGURE_TORI;

        strcpy(toriTail, &q[s]); /* tori */
        strrev(toriTail);

        if( threePlaces(toriTail[2], toriTail[1], toriTail[0]) ) {
            if(request_length > 3) {
                if(case_sensitive) {
                    p = &q[s]; /* tori */
                } else {
                    k = 0;
                    for(b = &q[s]; *b != '\0'; ++b) {
                        buffer[k++] = tolower(*b);
                    }

                    buffer[k] = '\0';
                    p = &buffer[0];
                }

                b = strstr(p, request);
                u = 0;
                while(p != b) {
                    p++;
                    u++;
                }

                if(u != TEN_FIGURE_TORI - TSEU_LENGTH) {
                    continue;
                }

            }

        } else {
            continue;
        }

        strcpy(matched, &q[s]); /* tori */
        count += 1;

/* Expressing the key as hexadecimal */
        buffer[0] = '\0';
        q = &pass[0];
        while(*q != '\0') {
            c = charToInteger(*q);
            strcat(buffer, &h[c][0]); /* hexadecimal */
            ++q;
        }

        strcat(buffer, FROM_TO);
        strcat(buffer, matched);
        voyaMessageFlush(buffer);

        sprintf(buffer, "%s%d | %s", TOTAL_COLON, count, matched);
        pop_front();
        push_back(buffer);
    }

    free(hugeTable);
    FreeLibrary(cryptGNU);
    closeVoyaError();
    return 0;
}

int seekerAsStandardSeek(void) {
    char *p;
    char *q;
    char buffer[SMALL_BUFFER_SIZE];
    char h[256][3];
    char matched[SMALL_BUFFER_SIZE];
    char pass[ CHARACTER_COUNT + 2 ];
    char request[REQUEST_SIZE];
    CRYPT crypt;
    double sum;
    HMODULE cryptGNU;
    int c, idling, interim_report, s;
    int count = 0;
    int efforts = 0;
    int request_length;
    unsigned long d;

/* request */
    if( settingBy(VOYA_CSV) ){
        readLabels();
        request_length = strlen(vs->request);
        if( request_length < 1 ) {
            voyaMessageFlush("request_length < 1");
            closeVoyaError();
            return REQUEST_LENGTH_ERROR;
        } else {
            strcpy(request, vs->request);
        }

    } else {
        voyaMessageFlush("settingBy(VOYA_CSV)");
        closeVoyaError();
        return VOYA_CSV_ERROR;
    }

/* positive numbers */
    idling = vs->idling;
    if(idling < 0) {
        voyaMessageFlush("idling < 0");
        closeVoyaError();
        return IDLING_ERROR;
    }

    interim_report = vs->interim_report;
    if(interim_report < 1) {
        voyaMessageFlush("interim_report < 1");
        closeVoyaError();
        return INTERIM_REPORT_ERROR;
    }

/* GNU crypt.dll */
    cryptGNU = LoadLibrary("crypt.dll");
    crypt = (CRYPT) GetProcAddress(cryptGNU, "crypt");

/* hexadecimal */
    strcpy(&h[  0][0], "00"); strcpy(&h[  1][0], "01"); strcpy(&h[  2][0], "02"); strcpy(&h[  3][0], "03"); strcpy(&h[  4][0], "04"); strcpy(&h[  5][0], "05"); strcpy(&h[  6][0], "06"); strcpy(&h[  7][0], "07"); strcpy(&h[  8][0], "08"); strcpy(&h[  9][0], "09"); strcpy(&h[ 10][0], "0A"); strcpy(&h[ 11][0], "0B");
    strcpy(&h[ 12][0], "0C"); strcpy(&h[ 13][0], "0D"); strcpy(&h[ 14][0], "0E"); strcpy(&h[ 15][0], "0F"); strcpy(&h[ 16][0], "10"); strcpy(&h[ 17][0], "11"); strcpy(&h[ 18][0], "12"); strcpy(&h[ 19][0], "13"); strcpy(&h[ 20][0], "14"); strcpy(&h[ 21][0], "15"); strcpy(&h[ 22][0], "16"); strcpy(&h[ 23][0], "17");
    strcpy(&h[ 24][0], "18"); strcpy(&h[ 25][0], "19"); strcpy(&h[ 26][0], "1A"); strcpy(&h[ 27][0], "1B"); strcpy(&h[ 28][0], "1C"); strcpy(&h[ 29][0], "1D"); strcpy(&h[ 30][0], "1E"); strcpy(&h[ 31][0], "1F"); strcpy(&h[ 32][0], "20"); strcpy(&h[ 33][0], "21"); strcpy(&h[ 34][0], "22"); strcpy(&h[ 35][0], "23");
    strcpy(&h[ 36][0], "24"); strcpy(&h[ 37][0], "25"); strcpy(&h[ 38][0], "26"); strcpy(&h[ 39][0], "27"); strcpy(&h[ 40][0], "28"); strcpy(&h[ 41][0], "29"); strcpy(&h[ 42][0], "2A"); strcpy(&h[ 43][0], "2B"); strcpy(&h[ 44][0], "2C"); strcpy(&h[ 45][0], "2D"); strcpy(&h[ 46][0], "2E"); strcpy(&h[ 47][0], "2F");
    strcpy(&h[ 48][0], "30"); strcpy(&h[ 49][0], "31"); strcpy(&h[ 50][0], "32"); strcpy(&h[ 51][0], "33"); strcpy(&h[ 52][0], "34"); strcpy(&h[ 53][0], "35"); strcpy(&h[ 54][0], "36"); strcpy(&h[ 55][0], "37"); strcpy(&h[ 56][0], "38"); strcpy(&h[ 57][0], "39"); strcpy(&h[ 58][0], "3A"); strcpy(&h[ 59][0], "3B");
    strcpy(&h[ 60][0], "3C"); strcpy(&h[ 61][0], "3D"); strcpy(&h[ 62][0], "3E"); strcpy(&h[ 63][0], "3F"); strcpy(&h[ 64][0], "40"); strcpy(&h[ 65][0], "41"); strcpy(&h[ 66][0], "42"); strcpy(&h[ 67][0], "43"); strcpy(&h[ 68][0], "44"); strcpy(&h[ 69][0], "45"); strcpy(&h[ 70][0], "46"); strcpy(&h[ 71][0], "47");
    strcpy(&h[ 72][0], "48"); strcpy(&h[ 73][0], "49"); strcpy(&h[ 74][0], "4A"); strcpy(&h[ 75][0], "4B"); strcpy(&h[ 76][0], "4C"); strcpy(&h[ 77][0], "4D"); strcpy(&h[ 78][0], "4E"); strcpy(&h[ 79][0], "4F"); strcpy(&h[ 80][0], "50"); strcpy(&h[ 81][0], "51"); strcpy(&h[ 82][0], "52"); strcpy(&h[ 83][0], "53");
    strcpy(&h[ 84][0], "54"); strcpy(&h[ 85][0], "55"); strcpy(&h[ 86][0], "56"); strcpy(&h[ 87][0], "57"); strcpy(&h[ 88][0], "58"); strcpy(&h[ 89][0], "59"); strcpy(&h[ 90][0], "5A"); strcpy(&h[ 91][0], "5B"); strcpy(&h[ 92][0], "5C"); strcpy(&h[ 93][0], "5D"); strcpy(&h[ 94][0], "5E"); strcpy(&h[ 95][0], "5F");
    strcpy(&h[ 96][0], "60"); strcpy(&h[ 97][0], "61"); strcpy(&h[ 98][0], "62"); strcpy(&h[ 99][0], "63"); strcpy(&h[100][0], "64"); strcpy(&h[101][0], "65"); strcpy(&h[102][0], "66"); strcpy(&h[103][0], "67"); strcpy(&h[104][0], "68"); strcpy(&h[105][0], "69"); strcpy(&h[106][0], "6A"); strcpy(&h[107][0], "6B");
    strcpy(&h[108][0], "6C"); strcpy(&h[109][0], "6D"); strcpy(&h[110][0], "6E"); strcpy(&h[111][0], "6F"); strcpy(&h[112][0], "70"); strcpy(&h[113][0], "71"); strcpy(&h[114][0], "72"); strcpy(&h[115][0], "73"); strcpy(&h[116][0], "74"); strcpy(&h[117][0], "75"); strcpy(&h[118][0], "76"); strcpy(&h[119][0], "77");
    strcpy(&h[120][0], "78"); strcpy(&h[121][0], "79"); strcpy(&h[122][0], "7A"); strcpy(&h[123][0], "7B"); strcpy(&h[124][0], "7C"); strcpy(&h[125][0], "7D"); strcpy(&h[126][0], "7E"); strcpy(&h[127][0], "7F"); strcpy(&h[128][0], "80"); strcpy(&h[129][0], "81"); strcpy(&h[130][0], "82"); strcpy(&h[131][0], "83");
    strcpy(&h[132][0], "84"); strcpy(&h[133][0], "85"); strcpy(&h[134][0], "86"); strcpy(&h[135][0], "87"); strcpy(&h[136][0], "88"); strcpy(&h[137][0], "89"); strcpy(&h[138][0], "8A"); strcpy(&h[139][0], "8B"); strcpy(&h[140][0], "8C"); strcpy(&h[141][0], "8D"); strcpy(&h[142][0], "8E"); strcpy(&h[143][0], "8F");
    strcpy(&h[144][0], "90"); strcpy(&h[145][0], "91"); strcpy(&h[146][0], "92"); strcpy(&h[147][0], "93"); strcpy(&h[148][0], "94"); strcpy(&h[149][0], "95"); strcpy(&h[150][0], "96"); strcpy(&h[151][0], "97"); strcpy(&h[152][0], "98"); strcpy(&h[153][0], "99"); strcpy(&h[154][0], "9A"); strcpy(&h[155][0], "9B");
    strcpy(&h[156][0], "9C"); strcpy(&h[157][0], "9D"); strcpy(&h[158][0], "9E"); strcpy(&h[159][0], "9F"); strcpy(&h[160][0], "A0"); strcpy(&h[161][0], "A1"); strcpy(&h[162][0], "A2"); strcpy(&h[163][0], "A3"); strcpy(&h[164][0], "A4"); strcpy(&h[165][0], "A5"); strcpy(&h[166][0], "A6"); strcpy(&h[167][0], "A7");
    strcpy(&h[168][0], "A8"); strcpy(&h[169][0], "A9"); strcpy(&h[170][0], "AA"); strcpy(&h[171][0], "AB"); strcpy(&h[172][0], "AC"); strcpy(&h[173][0], "AD"); strcpy(&h[174][0], "AE"); strcpy(&h[175][0], "AF"); strcpy(&h[176][0], "B0"); strcpy(&h[177][0], "B1"); strcpy(&h[178][0], "B2"); strcpy(&h[179][0], "B3");
    strcpy(&h[180][0], "B4"); strcpy(&h[181][0], "B5"); strcpy(&h[182][0], "B6"); strcpy(&h[183][0], "B7"); strcpy(&h[184][0], "B8"); strcpy(&h[185][0], "B9"); strcpy(&h[186][0], "BA"); strcpy(&h[187][0], "BB"); strcpy(&h[188][0], "BC"); strcpy(&h[189][0], "BD"); strcpy(&h[190][0], "BE"); strcpy(&h[191][0], "BF");
    strcpy(&h[192][0], "C0"); strcpy(&h[193][0], "C1"); strcpy(&h[194][0], "C2"); strcpy(&h[195][0], "C3"); strcpy(&h[196][0], "C4"); strcpy(&h[197][0], "C5"); strcpy(&h[198][0], "C6"); strcpy(&h[199][0], "C7"); strcpy(&h[200][0], "C8"); strcpy(&h[201][0], "C9"); strcpy(&h[202][0], "CA"); strcpy(&h[203][0], "CB");
    strcpy(&h[204][0], "CC"); strcpy(&h[205][0], "CD"); strcpy(&h[206][0], "CE"); strcpy(&h[207][0], "CF"); strcpy(&h[208][0], "D0"); strcpy(&h[209][0], "D1"); strcpy(&h[210][0], "D2"); strcpy(&h[211][0], "D3"); strcpy(&h[212][0], "D4"); strcpy(&h[213][0], "D5"); strcpy(&h[214][0], "D6"); strcpy(&h[215][0], "D7");
    strcpy(&h[216][0], "D8"); strcpy(&h[217][0], "D9"); strcpy(&h[218][0], "DA"); strcpy(&h[219][0], "DB"); strcpy(&h[220][0], "DC"); strcpy(&h[221][0], "DD"); strcpy(&h[222][0], "DE"); strcpy(&h[223][0], "DF"); strcpy(&h[224][0], "E0"); strcpy(&h[225][0], "E1"); strcpy(&h[226][0], "E2"); strcpy(&h[227][0], "E3");
    strcpy(&h[228][0], "E4"); strcpy(&h[229][0], "E5"); strcpy(&h[230][0], "E6"); strcpy(&h[231][0], "E7"); strcpy(&h[232][0], "E8"); strcpy(&h[233][0], "E9"); strcpy(&h[234][0], "EA"); strcpy(&h[235][0], "EB"); strcpy(&h[236][0], "EC"); strcpy(&h[237][0], "ED"); strcpy(&h[238][0], "EE"); strcpy(&h[239][0], "EF");
    strcpy(&h[240][0], "F0"); strcpy(&h[241][0], "F1"); strcpy(&h[242][0], "F2"); strcpy(&h[243][0], "F3"); strcpy(&h[244][0], "F4"); strcpy(&h[245][0], "F5"); strcpy(&h[246][0], "F6"); strcpy(&h[247][0], "F7"); strcpy(&h[248][0], "F8"); strcpy(&h[249][0], "F9"); strcpy(&h[250][0], "FA"); strcpy(&h[251][0], "FB");
    strcpy(&h[252][0], "FC"); strcpy(&h[253][0], "FD"); strcpy(&h[254][0], "FE"); strcpy(&h[255][0], "FF");

/* Setting a list of repeated items */
    sum = shiftJisKanaAscii();

    switch( sumOfWeight(sum) ) {
    case -1:
        voyaMessage(TOO_LARGE_SUM);
        voyaSumFlush(sum);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    case 0:
        voyaMessageFlush(SUM_EQUALS_ZERO);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    }

    while( repeating() ){}

/* Setting Mersenne Twister (MT) */
    setMT(TIME_USED_AS_SEED, idling);

    makeBatchFile();
    while(! terminated) {
        efforts += 1;
        if(efforts == interim_report) {
            if( voyaCtrlTextTouched() ) {
                break;
            }

            efforts = 0;
        }

/* Generating random numbers to produce a key */
        pass[0] = '\0';
        s = 0;
        while(s < CHARACTER_COUNT) { /* s may not equal 8 or 9. */
            d = randomIndex();
            strcat(pass, &character[d][0]);
            s += width[d];
        }

/* Encrypting to produce a tori */
        pass[CHARACTER_COUNT] = '\0';
        q = crypt(pass, "..");
        s = strlen(q) - TEN_FIGURE_TORI;

        p = &q[s]; /* tori */
        p = strstr(p, request);
        if(p == NULL) {
            continue;
        }

        strcpy(matched, &q[s]); /* tori */
        count += 1;

/* Expressing the key as hexadecimal */
        buffer[0] = '\0';
        q = &pass[0];
        while(*q != '\0') {
            c = charToInteger(*q);
            strcat(buffer, &h[c][0]); /* hexadecimal */
            ++q;
        }

        strcat(buffer, FROM_TO);
        strcat(buffer, matched);
        voyaMessageFlush(buffer);

        sprintf(buffer, "%s%d | %s", TOTAL_COLON, count, matched);
        pop_front();
        push_back(buffer);
    }

    FreeLibrary(cryptGNU);
    closeVoyaError();
    return 0;
}

int seekerAsUnlessCaseSensitive(void) {
    char *b;
    char *q;
    char buffer[SMALL_BUFFER_SIZE];
    char h[256][3];
    char matched[SMALL_BUFFER_SIZE];
    char pass[ CHARACTER_COUNT + 2 ];
    char request[REQUEST_SIZE];
    CRYPT crypt;
    double sum;
    HMODULE cryptGNU;
    int c, idling, interim_report, k, s;
    int count = 0;
    int efforts = 0;
    int request_length;
    unsigned long d;

/* request */
    if( settingBy(VOYA_CSV) ){
        readLabels();
        request_length = strlen(vs->request);
        if( request_length < 1 ) {
            voyaMessageFlush("request_length < 1");
            closeVoyaError();
            return REQUEST_LENGTH_ERROR;
        } else {
            strcpy(request, vs->request);
        }

    } else {
        voyaMessageFlush("settingBy(VOYA_CSV)");
        closeVoyaError();
        return VOYA_CSV_ERROR;
    }

/* positive numbers */
    idling = vs->idling;
    if(idling < 0) {
        voyaMessageFlush("idling < 0");
        closeVoyaError();
        return IDLING_ERROR;
    }

    interim_report = vs->interim_report;
    if(interim_report < 1) {
        voyaMessageFlush("interim_report < 1");
        closeVoyaError();
        return INTERIM_REPORT_ERROR;
    }

/* GNU crypt.dll */
    cryptGNU = LoadLibrary("crypt.dll");
    crypt = (CRYPT) GetProcAddress(cryptGNU, "crypt");

/* hexadecimal */
    strcpy(&h[  0][0], "00"); strcpy(&h[  1][0], "01"); strcpy(&h[  2][0], "02"); strcpy(&h[  3][0], "03"); strcpy(&h[  4][0], "04"); strcpy(&h[  5][0], "05"); strcpy(&h[  6][0], "06"); strcpy(&h[  7][0], "07"); strcpy(&h[  8][0], "08"); strcpy(&h[  9][0], "09"); strcpy(&h[ 10][0], "0A"); strcpy(&h[ 11][0], "0B");
    strcpy(&h[ 12][0], "0C"); strcpy(&h[ 13][0], "0D"); strcpy(&h[ 14][0], "0E"); strcpy(&h[ 15][0], "0F"); strcpy(&h[ 16][0], "10"); strcpy(&h[ 17][0], "11"); strcpy(&h[ 18][0], "12"); strcpy(&h[ 19][0], "13"); strcpy(&h[ 20][0], "14"); strcpy(&h[ 21][0], "15"); strcpy(&h[ 22][0], "16"); strcpy(&h[ 23][0], "17");
    strcpy(&h[ 24][0], "18"); strcpy(&h[ 25][0], "19"); strcpy(&h[ 26][0], "1A"); strcpy(&h[ 27][0], "1B"); strcpy(&h[ 28][0], "1C"); strcpy(&h[ 29][0], "1D"); strcpy(&h[ 30][0], "1E"); strcpy(&h[ 31][0], "1F"); strcpy(&h[ 32][0], "20"); strcpy(&h[ 33][0], "21"); strcpy(&h[ 34][0], "22"); strcpy(&h[ 35][0], "23");
    strcpy(&h[ 36][0], "24"); strcpy(&h[ 37][0], "25"); strcpy(&h[ 38][0], "26"); strcpy(&h[ 39][0], "27"); strcpy(&h[ 40][0], "28"); strcpy(&h[ 41][0], "29"); strcpy(&h[ 42][0], "2A"); strcpy(&h[ 43][0], "2B"); strcpy(&h[ 44][0], "2C"); strcpy(&h[ 45][0], "2D"); strcpy(&h[ 46][0], "2E"); strcpy(&h[ 47][0], "2F");
    strcpy(&h[ 48][0], "30"); strcpy(&h[ 49][0], "31"); strcpy(&h[ 50][0], "32"); strcpy(&h[ 51][0], "33"); strcpy(&h[ 52][0], "34"); strcpy(&h[ 53][0], "35"); strcpy(&h[ 54][0], "36"); strcpy(&h[ 55][0], "37"); strcpy(&h[ 56][0], "38"); strcpy(&h[ 57][0], "39"); strcpy(&h[ 58][0], "3A"); strcpy(&h[ 59][0], "3B");
    strcpy(&h[ 60][0], "3C"); strcpy(&h[ 61][0], "3D"); strcpy(&h[ 62][0], "3E"); strcpy(&h[ 63][0], "3F"); strcpy(&h[ 64][0], "40"); strcpy(&h[ 65][0], "41"); strcpy(&h[ 66][0], "42"); strcpy(&h[ 67][0], "43"); strcpy(&h[ 68][0], "44"); strcpy(&h[ 69][0], "45"); strcpy(&h[ 70][0], "46"); strcpy(&h[ 71][0], "47");
    strcpy(&h[ 72][0], "48"); strcpy(&h[ 73][0], "49"); strcpy(&h[ 74][0], "4A"); strcpy(&h[ 75][0], "4B"); strcpy(&h[ 76][0], "4C"); strcpy(&h[ 77][0], "4D"); strcpy(&h[ 78][0], "4E"); strcpy(&h[ 79][0], "4F"); strcpy(&h[ 80][0], "50"); strcpy(&h[ 81][0], "51"); strcpy(&h[ 82][0], "52"); strcpy(&h[ 83][0], "53");
    strcpy(&h[ 84][0], "54"); strcpy(&h[ 85][0], "55"); strcpy(&h[ 86][0], "56"); strcpy(&h[ 87][0], "57"); strcpy(&h[ 88][0], "58"); strcpy(&h[ 89][0], "59"); strcpy(&h[ 90][0], "5A"); strcpy(&h[ 91][0], "5B"); strcpy(&h[ 92][0], "5C"); strcpy(&h[ 93][0], "5D"); strcpy(&h[ 94][0], "5E"); strcpy(&h[ 95][0], "5F");
    strcpy(&h[ 96][0], "60"); strcpy(&h[ 97][0], "61"); strcpy(&h[ 98][0], "62"); strcpy(&h[ 99][0], "63"); strcpy(&h[100][0], "64"); strcpy(&h[101][0], "65"); strcpy(&h[102][0], "66"); strcpy(&h[103][0], "67"); strcpy(&h[104][0], "68"); strcpy(&h[105][0], "69"); strcpy(&h[106][0], "6A"); strcpy(&h[107][0], "6B");
    strcpy(&h[108][0], "6C"); strcpy(&h[109][0], "6D"); strcpy(&h[110][0], "6E"); strcpy(&h[111][0], "6F"); strcpy(&h[112][0], "70"); strcpy(&h[113][0], "71"); strcpy(&h[114][0], "72"); strcpy(&h[115][0], "73"); strcpy(&h[116][0], "74"); strcpy(&h[117][0], "75"); strcpy(&h[118][0], "76"); strcpy(&h[119][0], "77");
    strcpy(&h[120][0], "78"); strcpy(&h[121][0], "79"); strcpy(&h[122][0], "7A"); strcpy(&h[123][0], "7B"); strcpy(&h[124][0], "7C"); strcpy(&h[125][0], "7D"); strcpy(&h[126][0], "7E"); strcpy(&h[127][0], "7F"); strcpy(&h[128][0], "80"); strcpy(&h[129][0], "81"); strcpy(&h[130][0], "82"); strcpy(&h[131][0], "83");
    strcpy(&h[132][0], "84"); strcpy(&h[133][0], "85"); strcpy(&h[134][0], "86"); strcpy(&h[135][0], "87"); strcpy(&h[136][0], "88"); strcpy(&h[137][0], "89"); strcpy(&h[138][0], "8A"); strcpy(&h[139][0], "8B"); strcpy(&h[140][0], "8C"); strcpy(&h[141][0], "8D"); strcpy(&h[142][0], "8E"); strcpy(&h[143][0], "8F");
    strcpy(&h[144][0], "90"); strcpy(&h[145][0], "91"); strcpy(&h[146][0], "92"); strcpy(&h[147][0], "93"); strcpy(&h[148][0], "94"); strcpy(&h[149][0], "95"); strcpy(&h[150][0], "96"); strcpy(&h[151][0], "97"); strcpy(&h[152][0], "98"); strcpy(&h[153][0], "99"); strcpy(&h[154][0], "9A"); strcpy(&h[155][0], "9B");
    strcpy(&h[156][0], "9C"); strcpy(&h[157][0], "9D"); strcpy(&h[158][0], "9E"); strcpy(&h[159][0], "9F"); strcpy(&h[160][0], "A0"); strcpy(&h[161][0], "A1"); strcpy(&h[162][0], "A2"); strcpy(&h[163][0], "A3"); strcpy(&h[164][0], "A4"); strcpy(&h[165][0], "A5"); strcpy(&h[166][0], "A6"); strcpy(&h[167][0], "A7");
    strcpy(&h[168][0], "A8"); strcpy(&h[169][0], "A9"); strcpy(&h[170][0], "AA"); strcpy(&h[171][0], "AB"); strcpy(&h[172][0], "AC"); strcpy(&h[173][0], "AD"); strcpy(&h[174][0], "AE"); strcpy(&h[175][0], "AF"); strcpy(&h[176][0], "B0"); strcpy(&h[177][0], "B1"); strcpy(&h[178][0], "B2"); strcpy(&h[179][0], "B3");
    strcpy(&h[180][0], "B4"); strcpy(&h[181][0], "B5"); strcpy(&h[182][0], "B6"); strcpy(&h[183][0], "B7"); strcpy(&h[184][0], "B8"); strcpy(&h[185][0], "B9"); strcpy(&h[186][0], "BA"); strcpy(&h[187][0], "BB"); strcpy(&h[188][0], "BC"); strcpy(&h[189][0], "BD"); strcpy(&h[190][0], "BE"); strcpy(&h[191][0], "BF");
    strcpy(&h[192][0], "C0"); strcpy(&h[193][0], "C1"); strcpy(&h[194][0], "C2"); strcpy(&h[195][0], "C3"); strcpy(&h[196][0], "C4"); strcpy(&h[197][0], "C5"); strcpy(&h[198][0], "C6"); strcpy(&h[199][0], "C7"); strcpy(&h[200][0], "C8"); strcpy(&h[201][0], "C9"); strcpy(&h[202][0], "CA"); strcpy(&h[203][0], "CB");
    strcpy(&h[204][0], "CC"); strcpy(&h[205][0], "CD"); strcpy(&h[206][0], "CE"); strcpy(&h[207][0], "CF"); strcpy(&h[208][0], "D0"); strcpy(&h[209][0], "D1"); strcpy(&h[210][0], "D2"); strcpy(&h[211][0], "D3"); strcpy(&h[212][0], "D4"); strcpy(&h[213][0], "D5"); strcpy(&h[214][0], "D6"); strcpy(&h[215][0], "D7");
    strcpy(&h[216][0], "D8"); strcpy(&h[217][0], "D9"); strcpy(&h[218][0], "DA"); strcpy(&h[219][0], "DB"); strcpy(&h[220][0], "DC"); strcpy(&h[221][0], "DD"); strcpy(&h[222][0], "DE"); strcpy(&h[223][0], "DF"); strcpy(&h[224][0], "E0"); strcpy(&h[225][0], "E1"); strcpy(&h[226][0], "E2"); strcpy(&h[227][0], "E3");
    strcpy(&h[228][0], "E4"); strcpy(&h[229][0], "E5"); strcpy(&h[230][0], "E6"); strcpy(&h[231][0], "E7"); strcpy(&h[232][0], "E8"); strcpy(&h[233][0], "E9"); strcpy(&h[234][0], "EA"); strcpy(&h[235][0], "EB"); strcpy(&h[236][0], "EC"); strcpy(&h[237][0], "ED"); strcpy(&h[238][0], "EE"); strcpy(&h[239][0], "EF");
    strcpy(&h[240][0], "F0"); strcpy(&h[241][0], "F1"); strcpy(&h[242][0], "F2"); strcpy(&h[243][0], "F3"); strcpy(&h[244][0], "F4"); strcpy(&h[245][0], "F5"); strcpy(&h[246][0], "F6"); strcpy(&h[247][0], "F7"); strcpy(&h[248][0], "F8"); strcpy(&h[249][0], "F9"); strcpy(&h[250][0], "FA"); strcpy(&h[251][0], "FB");
    strcpy(&h[252][0], "FC"); strcpy(&h[253][0], "FD"); strcpy(&h[254][0], "FE"); strcpy(&h[255][0], "FF");

/* Setting a list of repeated items */
    sum = shiftJisKanaAscii();

    switch( sumOfWeight(sum) ) {
    case -1:
        voyaMessage(TOO_LARGE_SUM);
        voyaSumFlush(sum);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    case 0:
        voyaMessageFlush(SUM_EQUALS_ZERO);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    }

    while( repeating() ){}

/* Setting Mersenne Twister (MT) */
    setMT(TIME_USED_AS_SEED, idling);

    makeBatchFile();
    while(! terminated) {
        efforts += 1;
        if(efforts == interim_report) {
            if( voyaCtrlTextTouched() ) {
                break;
            }

            efforts = 0;
        }

/* Generating random numbers to produce a key */
        pass[0] = '\0';
        s = 0;
        while(s < CHARACTER_COUNT) { /* s may not equal 8 or 9. */
            d = randomIndex();
            strcat(pass, &character[d][0]);
            s += width[d];
        }

/* Encrypting to produce a tori */
        pass[CHARACTER_COUNT] = '\0';
        q = crypt(pass, "..");
        s = strlen(q) - TEN_FIGURE_TORI;

        k = 0;
        for(b = &q[s]; *b != '\0'; ++b) {
            buffer[k++] = tolower(*b);
        }

        buffer[k] = '\0';
        b = strstr(buffer, request);
        if(b == NULL) {
            continue;
        }

        strcpy(matched, &q[s]); /* tori */
        count += 1;

/* Expressing the key as hexadecimal */
        buffer[0] = '\0';
        q = &pass[0];
        while(*q != '\0') {
            c = charToInteger(*q);
            strcat(buffer, &h[c][0]); /* hexadecimal */
            ++q;
        }

        strcat(buffer, FROM_TO);
        strcat(buffer, matched);
        voyaMessageFlush(buffer);

        sprintf(buffer, "%s%d | %s", TOTAL_COLON, count, matched);
        pop_front();
        push_back(buffer);
    }

    FreeLibrary(cryptGNU);
    closeVoyaError();
    return 0;
}

int seekerAsUpperCaseRightmost(void) {
    BOOL case_sensitive;
    char *b;
    char *p;
    char *q;
    char buffer[SMALL_BUFFER_SIZE];
    char h[256][3];
    char matched[SMALL_BUFFER_SIZE];
    char pass[ CHARACTER_COUNT + 2 ];
    char request[REQUEST_SIZE];
    char toriTail[REQUEST_SIZE];
    char tseu[REQUEST_SIZE];
    const int TSEU_LENGTH = 3;
    CRYPT crypt;
    double sum;
    HMODULE cryptGNU;
    int c, idling, interim_report, k, s, u;
    int count = 0;
    int efforts = 0;
    int request_length, reverseLength;
    unsigned long d;

/* request */
    if( settingBy(VOYA_CSV) ){
        readLabels();
        request_length = strlen(vs->request);
        if( request_length < 1 ) {
            voyaMessageFlush("request_length < 1");
            closeVoyaError();
            return REQUEST_LENGTH_ERROR;
        } else {
            strcpy(request, vs->request);
        }

    } else {
        voyaMessageFlush("settingBy(VOYA_CSV)");
        closeVoyaError();
        return VOYA_CSV_ERROR;
    }

/* positive numbers */
    idling = vs->idling;
    if(idling < 0) {
        voyaMessageFlush("idling < 0");
        closeVoyaError();
        return IDLING_ERROR;
    }

    interim_report = vs->interim_report;
    if(interim_report < 1) {
        voyaMessageFlush("interim_report < 1");
        closeVoyaError();
        return INTERIM_REPORT_ERROR;
    }

/* GNU crypt.dll */
    cryptGNU = LoadLibrary("crypt.dll");
    crypt = (CRYPT) GetProcAddress(cryptGNU, "crypt");

/* Huge table set by triplet so that threePlaces() can read boolean values */
    hugeTable = (BOOL *)malloc( HALF * HALF * HALF * sizeof(BOOL) );
    if(hugeTable == NULL) {
        voyaMessageFlush("hugeTable == NULL");
        FreeLibrary(cryptGNU);
        closeVoyaError();
        return BOOL_MALLOC_ERROR;
    }

    memset(hugeTable, 0, HALF * HALF * HALF * sizeof(BOOL) );

/* hexadecimal */
    strcpy(&h[  0][0], "00"); strcpy(&h[  1][0], "01"); strcpy(&h[  2][0], "02"); strcpy(&h[  3][0], "03"); strcpy(&h[  4][0], "04"); strcpy(&h[  5][0], "05"); strcpy(&h[  6][0], "06"); strcpy(&h[  7][0], "07"); strcpy(&h[  8][0], "08"); strcpy(&h[  9][0], "09"); strcpy(&h[ 10][0], "0A"); strcpy(&h[ 11][0], "0B");
    strcpy(&h[ 12][0], "0C"); strcpy(&h[ 13][0], "0D"); strcpy(&h[ 14][0], "0E"); strcpy(&h[ 15][0], "0F"); strcpy(&h[ 16][0], "10"); strcpy(&h[ 17][0], "11"); strcpy(&h[ 18][0], "12"); strcpy(&h[ 19][0], "13"); strcpy(&h[ 20][0], "14"); strcpy(&h[ 21][0], "15"); strcpy(&h[ 22][0], "16"); strcpy(&h[ 23][0], "17");
    strcpy(&h[ 24][0], "18"); strcpy(&h[ 25][0], "19"); strcpy(&h[ 26][0], "1A"); strcpy(&h[ 27][0], "1B"); strcpy(&h[ 28][0], "1C"); strcpy(&h[ 29][0], "1D"); strcpy(&h[ 30][0], "1E"); strcpy(&h[ 31][0], "1F"); strcpy(&h[ 32][0], "20"); strcpy(&h[ 33][0], "21"); strcpy(&h[ 34][0], "22"); strcpy(&h[ 35][0], "23");
    strcpy(&h[ 36][0], "24"); strcpy(&h[ 37][0], "25"); strcpy(&h[ 38][0], "26"); strcpy(&h[ 39][0], "27"); strcpy(&h[ 40][0], "28"); strcpy(&h[ 41][0], "29"); strcpy(&h[ 42][0], "2A"); strcpy(&h[ 43][0], "2B"); strcpy(&h[ 44][0], "2C"); strcpy(&h[ 45][0], "2D"); strcpy(&h[ 46][0], "2E"); strcpy(&h[ 47][0], "2F");
    strcpy(&h[ 48][0], "30"); strcpy(&h[ 49][0], "31"); strcpy(&h[ 50][0], "32"); strcpy(&h[ 51][0], "33"); strcpy(&h[ 52][0], "34"); strcpy(&h[ 53][0], "35"); strcpy(&h[ 54][0], "36"); strcpy(&h[ 55][0], "37"); strcpy(&h[ 56][0], "38"); strcpy(&h[ 57][0], "39"); strcpy(&h[ 58][0], "3A"); strcpy(&h[ 59][0], "3B");
    strcpy(&h[ 60][0], "3C"); strcpy(&h[ 61][0], "3D"); strcpy(&h[ 62][0], "3E"); strcpy(&h[ 63][0], "3F"); strcpy(&h[ 64][0], "40"); strcpy(&h[ 65][0], "41"); strcpy(&h[ 66][0], "42"); strcpy(&h[ 67][0], "43"); strcpy(&h[ 68][0], "44"); strcpy(&h[ 69][0], "45"); strcpy(&h[ 70][0], "46"); strcpy(&h[ 71][0], "47");
    strcpy(&h[ 72][0], "48"); strcpy(&h[ 73][0], "49"); strcpy(&h[ 74][0], "4A"); strcpy(&h[ 75][0], "4B"); strcpy(&h[ 76][0], "4C"); strcpy(&h[ 77][0], "4D"); strcpy(&h[ 78][0], "4E"); strcpy(&h[ 79][0], "4F"); strcpy(&h[ 80][0], "50"); strcpy(&h[ 81][0], "51"); strcpy(&h[ 82][0], "52"); strcpy(&h[ 83][0], "53");
    strcpy(&h[ 84][0], "54"); strcpy(&h[ 85][0], "55"); strcpy(&h[ 86][0], "56"); strcpy(&h[ 87][0], "57"); strcpy(&h[ 88][0], "58"); strcpy(&h[ 89][0], "59"); strcpy(&h[ 90][0], "5A"); strcpy(&h[ 91][0], "5B"); strcpy(&h[ 92][0], "5C"); strcpy(&h[ 93][0], "5D"); strcpy(&h[ 94][0], "5E"); strcpy(&h[ 95][0], "5F");
    strcpy(&h[ 96][0], "60"); strcpy(&h[ 97][0], "61"); strcpy(&h[ 98][0], "62"); strcpy(&h[ 99][0], "63"); strcpy(&h[100][0], "64"); strcpy(&h[101][0], "65"); strcpy(&h[102][0], "66"); strcpy(&h[103][0], "67"); strcpy(&h[104][0], "68"); strcpy(&h[105][0], "69"); strcpy(&h[106][0], "6A"); strcpy(&h[107][0], "6B");
    strcpy(&h[108][0], "6C"); strcpy(&h[109][0], "6D"); strcpy(&h[110][0], "6E"); strcpy(&h[111][0], "6F"); strcpy(&h[112][0], "70"); strcpy(&h[113][0], "71"); strcpy(&h[114][0], "72"); strcpy(&h[115][0], "73"); strcpy(&h[116][0], "74"); strcpy(&h[117][0], "75"); strcpy(&h[118][0], "76"); strcpy(&h[119][0], "77");
    strcpy(&h[120][0], "78"); strcpy(&h[121][0], "79"); strcpy(&h[122][0], "7A"); strcpy(&h[123][0], "7B"); strcpy(&h[124][0], "7C"); strcpy(&h[125][0], "7D"); strcpy(&h[126][0], "7E"); strcpy(&h[127][0], "7F"); strcpy(&h[128][0], "80"); strcpy(&h[129][0], "81"); strcpy(&h[130][0], "82"); strcpy(&h[131][0], "83");
    strcpy(&h[132][0], "84"); strcpy(&h[133][0], "85"); strcpy(&h[134][0], "86"); strcpy(&h[135][0], "87"); strcpy(&h[136][0], "88"); strcpy(&h[137][0], "89"); strcpy(&h[138][0], "8A"); strcpy(&h[139][0], "8B"); strcpy(&h[140][0], "8C"); strcpy(&h[141][0], "8D"); strcpy(&h[142][0], "8E"); strcpy(&h[143][0], "8F");
    strcpy(&h[144][0], "90"); strcpy(&h[145][0], "91"); strcpy(&h[146][0], "92"); strcpy(&h[147][0], "93"); strcpy(&h[148][0], "94"); strcpy(&h[149][0], "95"); strcpy(&h[150][0], "96"); strcpy(&h[151][0], "97"); strcpy(&h[152][0], "98"); strcpy(&h[153][0], "99"); strcpy(&h[154][0], "9A"); strcpy(&h[155][0], "9B");
    strcpy(&h[156][0], "9C"); strcpy(&h[157][0], "9D"); strcpy(&h[158][0], "9E"); strcpy(&h[159][0], "9F"); strcpy(&h[160][0], "A0"); strcpy(&h[161][0], "A1"); strcpy(&h[162][0], "A2"); strcpy(&h[163][0], "A3"); strcpy(&h[164][0], "A4"); strcpy(&h[165][0], "A5"); strcpy(&h[166][0], "A6"); strcpy(&h[167][0], "A7");
    strcpy(&h[168][0], "A8"); strcpy(&h[169][0], "A9"); strcpy(&h[170][0], "AA"); strcpy(&h[171][0], "AB"); strcpy(&h[172][0], "AC"); strcpy(&h[173][0], "AD"); strcpy(&h[174][0], "AE"); strcpy(&h[175][0], "AF"); strcpy(&h[176][0], "B0"); strcpy(&h[177][0], "B1"); strcpy(&h[178][0], "B2"); strcpy(&h[179][0], "B3");
    strcpy(&h[180][0], "B4"); strcpy(&h[181][0], "B5"); strcpy(&h[182][0], "B6"); strcpy(&h[183][0], "B7"); strcpy(&h[184][0], "B8"); strcpy(&h[185][0], "B9"); strcpy(&h[186][0], "BA"); strcpy(&h[187][0], "BB"); strcpy(&h[188][0], "BC"); strcpy(&h[189][0], "BD"); strcpy(&h[190][0], "BE"); strcpy(&h[191][0], "BF");
    strcpy(&h[192][0], "C0"); strcpy(&h[193][0], "C1"); strcpy(&h[194][0], "C2"); strcpy(&h[195][0], "C3"); strcpy(&h[196][0], "C4"); strcpy(&h[197][0], "C5"); strcpy(&h[198][0], "C6"); strcpy(&h[199][0], "C7"); strcpy(&h[200][0], "C8"); strcpy(&h[201][0], "C9"); strcpy(&h[202][0], "CA"); strcpy(&h[203][0], "CB");
    strcpy(&h[204][0], "CC"); strcpy(&h[205][0], "CD"); strcpy(&h[206][0], "CE"); strcpy(&h[207][0], "CF"); strcpy(&h[208][0], "D0"); strcpy(&h[209][0], "D1"); strcpy(&h[210][0], "D2"); strcpy(&h[211][0], "D3"); strcpy(&h[212][0], "D4"); strcpy(&h[213][0], "D5"); strcpy(&h[214][0], "D6"); strcpy(&h[215][0], "D7");
    strcpy(&h[216][0], "D8"); strcpy(&h[217][0], "D9"); strcpy(&h[218][0], "DA"); strcpy(&h[219][0], "DB"); strcpy(&h[220][0], "DC"); strcpy(&h[221][0], "DD"); strcpy(&h[222][0], "DE"); strcpy(&h[223][0], "DF"); strcpy(&h[224][0], "E0"); strcpy(&h[225][0], "E1"); strcpy(&h[226][0], "E2"); strcpy(&h[227][0], "E3");
    strcpy(&h[228][0], "E4"); strcpy(&h[229][0], "E5"); strcpy(&h[230][0], "E6"); strcpy(&h[231][0], "E7"); strcpy(&h[232][0], "E8"); strcpy(&h[233][0], "E9"); strcpy(&h[234][0], "EA"); strcpy(&h[235][0], "EB"); strcpy(&h[236][0], "EC"); strcpy(&h[237][0], "ED"); strcpy(&h[238][0], "EE"); strcpy(&h[239][0], "EF");
    strcpy(&h[240][0], "F0"); strcpy(&h[241][0], "F1"); strcpy(&h[242][0], "F2"); strcpy(&h[243][0], "F3"); strcpy(&h[244][0], "F4"); strcpy(&h[245][0], "F5"); strcpy(&h[246][0], "F6"); strcpy(&h[247][0], "F7"); strcpy(&h[248][0], "F8"); strcpy(&h[249][0], "F9"); strcpy(&h[250][0], "FA"); strcpy(&h[251][0], "FB");
    strcpy(&h[252][0], "FC"); strcpy(&h[253][0], "FD"); strcpy(&h[254][0], "FE"); strcpy(&h[255][0], "FF");

/* request */
    request_length = strlen(request);
    if(request_length < 3) {
        strcpy(reverseComplement, REVERSE_COMPLEMENT);
        strcat(reverseComplement, request);
        reverseLength = strlen(reverseComplement);
        request[3] = '\0';
        request[2] = reverseComplement[ reverseLength - 1 ];
        request[1] = reverseComplement[ reverseLength - 2 ];
        request[0] = reverseComplement[ reverseLength - 3 ];
        request_length = 3;
    }

    strcpy(tseu, request);
    strrev(tseu);

    case_sensitive = vs->case_sensitive;
    if(case_sensitive) {
        setByTriplet(tseu[2], tseu[1], tseu[0]);
    } else {
        setByTriplet(tseu[2], tseu[1], tseu[0]);
        setByTriplet(tseu[2], tseu[1], lowerCaseOf(tseu[0]) );
        setByTriplet(tseu[2], lowerCaseOf(tseu[1]), tseu[0]);
        setByTriplet(tseu[2], lowerCaseOf(tseu[1]), lowerCaseOf(tseu[0]) );
        setByTriplet( lowerCaseOf(tseu[2]), tseu[1], tseu[0]);
        setByTriplet( lowerCaseOf(tseu[2]), tseu[1], lowerCaseOf(tseu[0]) );
        setByTriplet( lowerCaseOf(tseu[2]), lowerCaseOf(tseu[1]), tseu[0]);
        setByTriplet( lowerCaseOf(tseu[2]), lowerCaseOf(tseu[1]), lowerCaseOf(tseu[0]) );
    }

/* Setting a list of repeated items */
    sum = shiftJisKanaAscii();

    switch( sumOfWeight(sum) ) {
    case -1:
        voyaMessage(TOO_LARGE_SUM);
        voyaSumFlush(sum);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    case 0:
        voyaMessageFlush(SUM_EQUALS_ZERO);
        defaultWeight();
        shiftJisKanaAscii();
        break;
    }

    while( repeating() ){}

/* Setting Mersenne Twister (MT) */
    setMT(TIME_USED_AS_SEED, idling);

    makeBatchFile();
    while(! terminated) {
        efforts += 1;
        if(efforts == interim_report) {
            if( voyaCtrlTextTouched() ) {
                break;
            }

            efforts = 0;
        }

/* Generating random numbers to produce a key */
        pass[0] = '\0';
        s = 0;
        while(s < CHARACTER_COUNT) { /* s may not equal 8 or 9. */
            d = randomIndex();
            strcat(pass, &character[d][0]);
            s += width[d];
        }

/* Encrypting to produce a tori */
        pass[CHARACTER_COUNT] = '\0';
        q = crypt(pass, "..");
        s = strlen(q) - TEN_FIGURE_TORI;

        strcpy(toriTail, &q[s]); /* tori */
        strrev(toriTail);

        if( threePlaces(toriTail[2], toriTail[1], toriTail[0]) ) {
            if(request_length > 3) {
                if(case_sensitive) {
                    p = &q[s]; /* tori */
                } else {
                    k = 0;
                    for(b = &q[s]; *b != '\0'; b++) {
                        buffer[k++] = toupper(*b);
                    }

                    buffer[k] = '\0';
                    p = &buffer[0];
                }

                b = strstr(p, request);
                u = 0;
                while(p != b) {
                    p++;
                    u++;
                }

                if(u != TEN_FIGURE_TORI - TSEU_LENGTH) {
                    continue;
                }

            }

        } else {
            continue;
        }

        strcpy(matched, &q[s]); /* tori */
        count += 1;

/* Expressing the key as hexadecimal */
        buffer[0] = '\0';
        q = &pass[0];
        while(*q != '\0') {
            c = charToInteger(*q);
            strcat(buffer, &h[c][0]); /* hexadecimal */
            ++q;
        }

        strcat(buffer, FROM_TO);
        strcat(buffer, matched);
        voyaMessageFlush(buffer);

        sprintf(buffer, "%s%d | %s", TOTAL_COLON, count, matched);
        pop_front();
        push_back(buffer);
    }

    free(hugeTable);
    FreeLibrary(cryptGNU);
    closeVoyaError();
    return 0;
}

int main(int argc, char *argv[]) {
    BOOL batch = 0; /* FALSE */
    BOOL earlyQuitting = 0; /* FALSE */
    BOOL quit = 0; /* FALSE */
    char *non_number;
    const BOOL WITHOUT_COMMENTS = 0; /* FALSE */
    const BOOL WITH_COMMENTS = TRUE;
    const int PARAMETER_SIZE = 2;
    const char ASCII[] = "-a";
    const char BATCH[] = "-b";
    const char DISPLAY[] = "-d";
    const char EARLY_QUITTING[] = "-Q";
    const char EXCLUDE[] = "-x";
    const char GMT[] = "-g"; /* universal time (UTC) */
    const char MESSAGES[] = "-m-";
    const char NORMALIZE[] = "-n";
    const char QUIT[] = "-q";
    const char RECOVERY[] = "-y";
    const char REMOVE[] = "-r";
    const char SALT[] = "-l";
    const char version[] = "-V";
    const char version_comment[] = "-VC";
    double sum;
    FILE *test;
    int i, number;
    
/* Setting according to VOYA_CTRL_TEXT */
    if( readVoyaCtrlTextBeforehand() ) {
        displayMode = vc->displayMode;
        leftmost_salt = vc->leftmostSalt;
        removeVoyaError = vc->removeVoyaError;
        universalTime = vc->universalTime;
    } else {
        fprintf(stderr, "%s\n", VOYA_CTRL_TEXT);
        return 1;
    }

/* Checking if VOYA_LOG exists */
    test = fopen(VOYA_LOG, "rt");
    if(test == NULL) {
        createVoyaLog(VOYA_LOG);
    } else {
        fclose(test);
    }

    useAscii = 0; /* FALSE */
    removeFirst = 0; /* FALSE */
    toBeNormalized = 0; /* FALSE */

// command line
    for(i = 0; i < argc; i++) {
        if(! strcmp(ASCII, argv[i]) ) {
            useAscii = TRUE;
        } else if(! strcmp(BATCH, argv[i]) ) {
            batch = TRUE;
        } else if(! strcmp(EARLY_QUITTING, argv[i]) ) {
            earlyQuitting = TRUE;
        } else if(! strcmp(EXCLUDE, argv[i]) ) {
            vc->excludeQuotesGreaterThan = TRUE;
        } else if(! strcmp(GMT, argv[i]) ) {
            universalTime = TRUE;
        } else if(! strcmp(MESSAGES, argv[i]) ) {
            removeVoyaError = 0; /* FALSE */
        } else if(! strcmp(NORMALIZE, argv[i]) ) {
            toBeNormalized = TRUE;
        } else if(! strcmp(QUIT, argv[i]) ) {
            quit = TRUE;
        } else if(! strcmp(RECOVERY, argv[i]) ) {
            recovery();
        } else if(! strcmp(REMOVE, argv[i]) ) {
            removeFirst = TRUE;
        } else if(! strcmp(SALT, argv[i]) ) {
            leftmost_salt = TRUE;
        } else if(! strcmp(version, argv[i]) ) {
            versionMessage(WITHOUT_COMMENTS);
            return 0;

        } else if(! strcmp(version_comment, argv[i]) ) {
            versionMessage(WITH_COMMENTS);
            return 0;

        } else {
            if( strlen(argv[i]) > PARAMETER_SIZE ) {
                non_number = parameter_of_numbered(argv[i], &number);

                if(! strcmp(DISPLAY, non_number) ) {
                    displayMode = number;
                    if(displayMode <= NO_DISPLAYING || LATEST_AND_TOTAL <= displayMode) {
                        displayMode = DISPLAY_TOTAL;
                    }

                }

                free(non_number);
            }

        }

    }

    if(batch) {
        if( voyaLogBatchProcessing() ) {
            return 0;
        } else {
            fprintf(stderr, "voyaLogBatchProcessing()");
            return 1;
        }

    }

    if(leftmost_salt) {
        useAscii = TRUE;
    }

    if(removeFirst) {
        removeVoyaErrorFiles();
        remove(REMOVE_ERROR_TEXT);
    }

    ve->removeVoyaError = removeVoyaError;
    vs->leftmost_salt = leftmost_salt;

    if(! leftmost_salt) {
        removeSalt();
    }

    if(earlyQuitting) {
        return 0;
    }

// Setting a signal handler
    signal(SIGINT, signal_handler);

/* ring buffer */
    ring_count = produce_ring_buffer(RING_COUNT);

/* Non-seeker for setting */
    vs->regular_expression = 0; /* FALSE */
    vs->leftmost = NON_SEEKER;

    seekerAsWhat();

    if(useAscii) {
        useNoCharacterButASCII();
        if(leftmost_salt) {
            vs->regular_expression = 0; /* FALSE */
            vs->leftmost = 1;
        }
    }

    if(toBeNormalized) {
        sum = shiftJisKanaAscii();
        normalizing(sum, AIM);
        writeLabelsEditedLines();
    }

    if(quit) {
        return 0;
    }

/* Starting */
    seekerAsWhat();

/* Adding tori to the log */
    if(! voyaLogBatchProcessing() ) {
        fprintf(stderr, "voyaLogBatchProcessing()\n");
        return 1;
    }

    return 0;
}

long tickCount(void) {
    long n = (long)time(NULL);
    return n;
}

void defaultWeight(void) {
    int a[ARRAY_LENGTH] = {1, 0, 524287, 400, 143, 1, 1, 1, 1, 1, 1, 1, 1, 143, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1};
    vs->ascii_weight = a[4];
    vs->capital_omega_weight = a[5];
    vs->capital_ya_weight = a[6];
    vs->capital_z_weight = a[7];
    vs->cap_weight = a[8];
    vs->circle_weight = a[9];
    vs->cup_weight = a[10];
    vs->double_integral_weight = a[11];
    vs->exists_weight = a[12];
    vs->hankaku_katakana_weight = a[13];
    vs->heisei_weight = a[14];
    vs->hiragana_weight = a[15];
    vs->jis_level_one_kanji_weight = a[16];
    vs->jis_level_two_kanji_weight = a[17];
    vs->katakana_weight = a[18];
    vs->keisen_weight = a[19];
    vs->nine_weight = a[20];
    vs->omega_weight = a[21];
    vs->paragraph_weight = a[22];
    vs->parallel_weight = a[23];
    vs->roman_weight = a[24];
    vs->square_meter_weight = a[25];
    vs->ya_weight = a[26];
    vs->z_weight = a[27];
}

void newTotal(void) {
    int k;
    int repetition = queue_size() - 1;
    int item = queue_begin;

    for(k = 0; k < repetition; k++) {
        item = next(item);
    }

    fprintf(stdout, "%s\n", queue[item]);
}

void random_salt(char *pair, char *salt) {
    static BOOL phase;
    static unsigned long seven_bit_group[4];
    unsigned long bits;

    if(phase) {
        pair[0] = salt[ seven_bit_group[1] ];
        pair[1] = salt[ seven_bit_group[0] ];
        pair[2] = '\0';
        phase = 0; /* FALSE */
    } else {
        bits = genrand_int32();
        seven_bit_group[0] = bits & 0x0000007F;
        bits >>= 7;
        seven_bit_group[1] = bits & 0x0000007F;
        bits >>= 7;
        seven_bit_group[2] = bits & 0x0000007F;
        bits >>= 7;
        seven_bit_group[3] = bits & 0x0000007F;

        pair[0] = salt[ seven_bit_group[3] ];
        pair[1] = salt[ seven_bit_group[2] ];
        pair[2] = '\0';
        phase = TRUE;
    }

}

void seekerAsWhat(void) {
    SEEKER seeker;

    openVoyaError();

    if(vs->regular_expression) {
        if(vs->dragon_seek) {
            seeker = seekerAsDragonSeek;
        } else {
            seeker = seekerAsRegularExpression;
        }
    } else {
        switch(vs->leftmost) {
        case NON_SEEKER:
            seeker = non_seeker;
            break;
        case -1:
            if(vs->lower_case) {
                seeker = seekerAsRightmostSeek;
            } else {
                seeker = seekerAsUpperCaseRightmost;
            }

            break;
        case 0:
            if(vs->case_sensitive) {
                seeker = seekerAsStandardSeek;
            } else {
                seeker = seekerAsUnlessCaseSensitive;
            }

            break;
        default:
            if(vs->leftmost_salt) {
                seeker = seekerAsLeftmostSalt;
            } else {
                seeker = seekerAsLeftmostSeek;
            }

        }

    }

// Getting the file time of VOYA_CTRL_TEXT
    untouched = modified_file(VOYA_CTRL_TEXT);

    terminated = 0; /* FALSE */
    switch( seeker() ) {
    case REQUEST_LENGTH_ERROR:
        fprintf(stderr, "REQUEST_LENGTH_ERROR\n");
        break;
    case VOYA_CSV_ERROR:
        fprintf(stderr, "VOYA_CSV_ERROR\n");
        break;
    case IDLING_ERROR:
        fprintf(stderr, "IDLING_ERROR\n");
        break;
    case INTERIM_REPORT_ERROR:
        fprintf(stderr, "INTERIM_REPORT_ERROR\n");
        break;
    case CRYPT_DLL_ERROR:
        fprintf(stderr, "CRYPT_DLL_ERROR\n");
        break;
    case GET_PROC_ADDRESS_ERROR:
        fprintf(stderr, "GET_PROC_ADDRESS_ERROR\n");
        break;
    case ERROR_COUNT:
        fprintf(stderr, "ERROR_COUNT\n");
        break;
    default:
        break;
    }
}

void showRing(void) {
    const int PIPE_GAP_SIZE = 2;
    const char NEW_LINE[] = "\n";
    const char PIPE_GAP[] = "| ";
    char *q;
    char buffer[BUFFER_SIZE];
    int k;
    int repetition = queue_size();
    int item = queue_begin;

    buffer[0] = '\0';
    for(k = 0; k < repetition; k++) {
        q = strstr(queue[item], PIPE_GAP);
        if(q != NULL) {
            q += PIPE_GAP_SIZE;
            strcat(buffer, q);
            strcat(buffer, NEW_LINE);
        }

        item = next(item);
    }

    fputs(buffer, stdout);
}

void signal_handler(int dummy) {
    terminated = TRUE;
}

void versionMessage(BOOL comments) {

    if(comments) {
        fprintf(stderr, "voya C-%1.2f\n\n", VERSION);
        fprintf(stderr, "voya -a # ascii \n");
        fprintf(stderr, "voya -b # batch \n");
        fprintf(stderr, "voya -d3 # display mode-3 \n");
        fprintf(stderr, "voya -g # GMT \n");
        fprintf(stderr, "voya -l # salt \n");
        fprintf(stderr, "voya -m- # No removing \n");
        fprintf(stderr, "voya -n # normalize \n");
        fprintf(stderr, "voya -q # quit \n");
        fprintf(stderr, "voya -r # Remove temporary files first. \n");
        fprintf(stderr, "voya -V # version \n");
        fprintf(stderr, "voya -VC # version with comments \n");
        fprintf(stderr, "voya -x # Exclude quotes. \n");
        fprintf(stderr, "voya -y # recovery \n");
    } else {
        fprintf(stderr, "voya C-%1.2f\n\n", VERSION);
        fprintf(stderr, "voya -a \n");
        fprintf(stderr, "voya -b \n");
        fprintf(stderr, "voya -d3 \n");
        fprintf(stderr, "voya -g \n");
        fprintf(stderr, "voya -l \n");
        fprintf(stderr, "voya -m- \n");
        fprintf(stderr, "voya -n \n");
        fprintf(stderr, "voya -q \n");
        fprintf(stderr, "voya -r \n");
        fprintf(stderr, "voya -V \n");
        fprintf(stderr, "voya -VC \n");
        fprintf(stderr, "voya -x \n");
        fprintf(stderr, "voya -y \n");
    }

}

