#ifndef VOYA_SETTING_H
#define VOYA_SETTING_H

#define AEIM_CHARACTER 13
#define ARRAY_LENGTH 28
#define CGKO_CHARACTER 6
#define CSV_COLUMN_COUNT 2
#define REPEATEDLY_NORMALIZING 30
#define SALT_ARRAY_SIZE 82
#define SALT_LINE 31
#define SHOULD_BE_USED_AS_TENTH_CHARACTER "., 2, 6, A, E, I, M, Q, U, Y, c, g, k, o, s or w should be used as the tenth character of tori."
#define VOYA_CSV "voya.csv"
#define WEIGHT_ARRAY_LENGTH 24
#include <ctype.h>
#include "Seek.h"
#include "voyaFile.h"

enum VOYA_CSV_LINES {UNAVAILABLE, REQUEST_LINE, LOG_LINE, LEFTMOST_LINE, CASE_SENSITIVE_LINE, REPORT_LINE, IDLING_LINE, ASCII_LINE};

BOOL copyLogFileName(char *sequence, int end);
BOOL copyRequest(char *sequence, int end);
BOOL copySalt(char *sequence, int end);
BOOL readLabels(void);
BOOL removeSalt(void);
BOOL settingBy(const char *fileName);
BOOL testSalt(int x);
BOOL writeLabelsEditedLines(void);
double shiftJisKanaAscii(void); /* voyaMain.c */
int commaShouldComeBeforeInteger(char *sequence, int length, int index);
void editedLinePrint(int line, int a);
void normalizing(double sum, double aim);
void recovery(void);
void useLowerCaseUnlessCaseSensitive(void);
void useNoCharacterButASCII(void);
void voyaCountFlush(int count); /* Seek.c */
void voyaMessage(const char *message); /* Seek.c */
void voyaMessageFlush(const char *message); /* Seek.c */
void voyaSumFlush(double sum); /* Seek.c */

#endif /* VOYA_SETTING_H */
